(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     70396,       1643]
NotebookOptionsPosition[     69364,       1605]
NotebookOutlinePosition[     69729,       1621]
CellTagsIndexPosition[     69686,       1618]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[{
 RowBox[{
  RowBox[{"Needs", "[", "\"\<MultivariateStatistics`\>\"", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ParallelNeeds", "[", "\"\<MultivariateStatistics`\>\"", "]"}], 
   ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ilogit", "[", "x_", "]"}], ":=", 
   RowBox[{
    RowBox[{"Exp", "[", "x", "]"}], "/", 
    RowBox[{"(", 
     RowBox[{"1", "+", 
      RowBox[{"Exp", "[", "x", "]"}]}], ")"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"logit", "[", "x_", "]"}], ":=", 
    RowBox[{"Log", "[", 
     RowBox[{"x", "/", 
      RowBox[{"(", 
       RowBox[{"1", "-", "x"}], ")"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"norm", "[", "x_", "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "y", "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"y", "=", 
        RowBox[{"x", "-", 
         RowBox[{"Mean", "[", "x", "]"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Variance", "[", "y", "]"}], ">", 
          RowBox[{"10", "^", 
           RowBox[{"(", 
            RowBox[{"-", "10"}], ")"}]}]}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"y", "=", 
           RowBox[{"y", "/", 
            RowBox[{"Sqrt", "[", 
             RowBox[{"Variance", "[", "y", "]"}], "]"}]}]}], ";"}]}], 
        "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", "y"}]}], 
     "\[IndentingNewLine]", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"loglike", "[", 
     RowBox[{"X_", ",", "sp_", ",", "be_", ",", "e_", ",", "padata_"}], "]"}],
     ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "tn", "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"tn", "=", 
        RowBox[{"ilogit", "[", 
         RowBox[{
          RowBox[{"X", ".", "be"}], "+", "e"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Log", "[", 
        RowBox[{
         RowBox[{"tn", "*", 
          RowBox[{"padata", "[", 
           RowBox[{"[", 
            RowBox[{"All", ",", "sp"}], "]"}], "]"}]}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"1", "-", "tn"}], ")"}], "*", 
          RowBox[{"(", 
           RowBox[{"1", "-", 
            RowBox[{"padata", "[", 
             RowBox[{"[", 
              RowBox[{"All", ",", "sp"}], "]"}], "]"}]}], ")"}]}]}], 
        "]"}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"loglikesite", "[", 
     RowBox[{"X_", ",", "site_", ",", "be_", ",", "e_", ",", "padata_"}], 
     "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "tn", "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"tn", "=", 
        RowBox[{"ilogit", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"X", "[", 
            RowBox[{"[", "site", "]"}], "]"}], ".", 
           RowBox[{"Transpose", "[", "be", "]"}]}], "+", "e"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Log", "[", 
        RowBox[{
         RowBox[{"tn", "*", 
          RowBox[{"padata", "[", 
           RowBox[{"[", 
            RowBox[{"site", ",", "All"}], "]"}], "]"}]}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"1", "-", "tn"}], ")"}], "*", 
          RowBox[{"(", 
           RowBox[{"1", "-", 
            RowBox[{"padata", "[", 
             RowBox[{"[", 
              RowBox[{"site", ",", "All"}], "]"}], "]"}]}], ")"}]}]}], 
        "]"}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"MCMC", "[", 
     RowBox[{
     "trans_", ",", "iter_", ",", "X_", ",", "y_", ",", "primuV_", ",", 
      "prisi2_", ",", "thin_", ",", "relax_", ",", "update_", ",", "ar_", ",",
       "be0_"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "n", ",", "m", ",", "k", ",", "reg", ",", "V", ",", "iV", ",", "be", 
        ",", "mu", ",", "e", ",", "si2", ",", "like1", ",", "like2", ",", 
        "like3", ",", "ac", ",", "ace", ",", "kk", ",", "kke", ",", "ta", ",",
         "nbe", ",", "nlike1", ",", "nlike2", ",", "si02", ",", "nu0", ",", 
        "nuS", ",", "v", ",", "siS2", ",", "mu0", ",", "Lambda0", ",", 
        "kappa0", ",", "mbe", ",", "S", ",", "num", ",", "Lambdam", ",", 
        "iLambdam", ",", "mum", ",", "kappam", ",", "ne", ",", "nlike3", ",", 
        "r", ",", "re", ",", "w", ",", "aa", ",", "Vk"}], "}"}], ",", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"n", ",", "m"}], "}"}], "=", 
        RowBox[{"Dimensions", "[", "y", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"n", ",", "k"}], "}"}], "=", 
        RowBox[{"Dimensions", "[", "X", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"reg", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"Flatten", "[", 
           RowBox[{"Position", "[", 
            RowBox[{
             RowBox[{"Round", "[", 
              RowBox[{"X", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "i"}], "]"}], "]"}], "]"}], ",", "1"}], 
            "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "7"}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"V", "=", 
        RowBox[{"IdentityMatrix", "[", "k", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"iV", "=", 
        RowBox[{"Inverse", "[", "V", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"be", "=", "be0"}], ";", "\[IndentingNewLine]", 
       RowBox[{"mu", "=", 
        RowBox[{"Mean", "[", "be", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"e", "=", 
        RowBox[{"Table", "[", 
         RowBox[{"0.", ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "n"}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"si2", "=", "1."}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"like1", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"loglike", "[", 
           RowBox[{"X", ",", "sp", ",", 
            RowBox[{"be", "[", 
             RowBox[{"[", "sp", "]"}], "]"}], ",", "e", ",", "y"}], "]"}], 
          ",", 
          RowBox[{"{", 
           RowBox[{"sp", ",", "m"}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"like2", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"be", "[", 
                RowBox[{"[", "sp", "]"}], "]"}], "-", "mu"}], ")"}], ".", 
             "iV", ".", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"be", "[", 
                RowBox[{"[", "sp", "]"}], "]"}], "-", "mu"}], ")"}]}]}], "/", 
           "2"}], ",", 
          RowBox[{"{", 
           RowBox[{"sp", ",", "m"}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"like3", "=", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"e", ".", "e"}]}], "/", 
         RowBox[{"(", "si2", ")"}]}]}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"ac", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"sp", ",", "m"}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"ace", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "n"}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"kk", "=", 
        RowBox[{"Table", "[", 
         RowBox[{"1.", ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "m"}], "}"}]}], "]"}]}], ";", " ", 
       "\[IndentingNewLine]", 
       RowBox[{"kke", "=", 
        RowBox[{"Table", "[", 
         RowBox[{"1.", ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "n"}], "}"}]}], "]"}]}], ";", " ", 
       "\[IndentingNewLine]", 
       RowBox[{"ta", "=", 
        RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"Do", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"update", "[", 
             RowBox[{"[", "1", "]"}], "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"(*", " ", 
             RowBox[{"update", " ", "be"}], " ", "*)"}], 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Do", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
                RowBox[{"nbe", "=", 
                 RowBox[{"be", "[", 
                  RowBox[{"[", "sp", "]"}], "]"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"nbe", "+=", 
                 RowBox[{"Random", "[", 
                  RowBox[{"MultinormalDistribution", "[", 
                   RowBox[{
                    RowBox[{"Table", "[", 
                    RowBox[{"0", ",", 
                    RowBox[{"{", 
                    RowBox[{"i", ",", "k"}], "}"}]}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"kk", "[", 
                    RowBox[{"[", "sp", "]"}], "]"}], "*", "V"}]}], "]"}], 
                  "]"}]}], ";", "\[IndentingNewLine]", 
                RowBox[{"nlike1", "=", 
                 RowBox[{"loglike", "[", 
                  RowBox[{"X", ",", "sp", ",", "nbe", ",", "e", ",", "y"}], 
                  "]"}]}], ";", "\[IndentingNewLine]", 
                RowBox[{"nlike2", "=", 
                 RowBox[{
                  RowBox[{"-", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{"nbe", "-", "mu"}], ")"}], ".", "iV", ".", 
                    RowBox[{"(", 
                    RowBox[{"nbe", "-", "mu"}], ")"}]}]}], "/", "2"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"ac", "[", 
                  RowBox[{"[", 
                   RowBox[{"sp", ",", "2"}], "]"}], "]"}], "+=", "1"}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"Random", "[", "]"}], "<", 
                   RowBox[{"Exp", "[", 
                    RowBox[{
                    RowBox[{"Total", "[", "nlike1", "]"}], "+", "nlike2", "-", 
                    RowBox[{"Total", "[", 
                    RowBox[{"like1", "[", 
                    RowBox[{"[", "sp", "]"}], "]"}], "]"}], "-", 
                    RowBox[{"like2", "[", 
                    RowBox[{"[", "sp", "]"}], "]"}]}], "]"}]}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"be", "[", 
                    RowBox[{"[", "sp", "]"}], "]"}], "=", "nbe"}], ";", 
                   "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"like1", "[", 
                    RowBox[{"[", "sp", "]"}], "]"}], "=", "nlike1"}], ";", 
                   "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"like2", "[", 
                    RowBox[{"[", "sp", "]"}], "]"}], "=", "nlike2"}], ";", 
                   "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"ac", "[", 
                    RowBox[{"[", 
                    RowBox[{"sp", ",", "1"}], "]"}], "]"}], "+=", "1"}], 
                   ";"}]}], "\[IndentingNewLine]", "]"}], ";"}], 
               "\[IndentingNewLine]", ",", 
               RowBox[{"{", 
                RowBox[{"sp", ",", "m"}], "}"}]}], "]"}], ";"}]}], 
           "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"update", "[", 
             RowBox[{"[", "2", "]"}], "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"(*", " ", 
             RowBox[{"UPDATE", " ", "si2"}], " ", "*)"}], 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"{", 
               RowBox[{"si02", ",", "nu0"}], "}"}], "=", "prisi2"}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"nuS", "=", 
              RowBox[{"nu0", "+", "n"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"v", "=", 
              RowBox[{
               RowBox[{"e", ".", "e"}], "/", "n"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"siS2", "=", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"nu0", " ", "si02"}], "+", 
                 RowBox[{"n", " ", "v"}]}], ")"}], "/", 
               RowBox[{"(", 
                RowBox[{"nu0", "+", "n"}], ")"}]}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"si2", "=", 
              RowBox[{"siS2", " ", 
               RowBox[{"nuS", "/", 
                RowBox[{"RandomReal", "[", 
                 RowBox[{"ChiSquareDistribution", "[", "nuS", "]"}], 
                 "]"}]}]}]}], ";"}]}], "\[IndentingNewLine]", "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"like3", "=", 
           RowBox[{
            RowBox[{"-", 
             RowBox[{"e", ".", "e"}]}], "/", 
            RowBox[{"(", "si2", ")"}]}]}], ";", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"update", "[", 
             RowBox[{"[", "3", "]"}], "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"(*", " ", 
             RowBox[{
              RowBox[{"UPDATE", " ", "V"}], ",", " ", "mu"}], " ", "*)"}], 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"{", 
               RowBox[{"mu0", ",", "Lambda0", ",", "kappa0", ",", "nu0"}], 
               "}"}], "=", "primuV"}], ";", "\[IndentingNewLine]", 
             RowBox[{"mbe", "=", 
              RowBox[{"Mean", "[", "be", "]"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"S", "=", 
              RowBox[{"Table", "[", 
               RowBox[{"0", ",", 
                RowBox[{"{", 
                 RowBox[{"i", ",", "k"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"j", ",", "k"}], "}"}]}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"Do", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
                RowBox[{"v", "=", 
                 RowBox[{"{", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"be", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "-", "mbe"}], ")"}], 
                  "}"}]}], ";", "\[IndentingNewLine]", 
                RowBox[{"S", "+=", 
                 RowBox[{
                  RowBox[{"Transpose", "[", "v", "]"}], ".", "v"}]}]}], 
               "\[IndentingNewLine]", ",", 
               RowBox[{"{", 
                RowBox[{"i", ",", "m"}], "}"}]}], "]"}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"num", "=", 
              RowBox[{"nu0", "+", "m"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"Lambdam", "=", 
              RowBox[{"Lambda0", "+", "S", "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"kappa0", " ", "m"}], ")"}], "/", 
                  RowBox[{"(", 
                   RowBox[{"kappa0", "+", "m"}], ")"}]}], ")"}], " ", 
                RowBox[{
                 RowBox[{"Transpose", "[", 
                  RowBox[{"{", 
                   RowBox[{"mbe", "-", "mu0"}], "}"}], "]"}], ".", 
                 RowBox[{"{", 
                  RowBox[{"mbe", "-", "mu0"}], "}"}]}]}]}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"iLambdam", "=", 
              RowBox[{"Inverse", "[", "Lambdam", "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"iLambdam", "=", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"iLambdam", "+", 
                 RowBox[{"Transpose", "[", "iLambdam", "]"}]}], ")"}], "/", 
               "2"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"V", "=", 
              RowBox[{"Inverse", "[", 
               RowBox[{"RandomReal", "[", 
                RowBox[{"WishartDistribution", "[", 
                 RowBox[{"iLambdam", ",", "num"}], "]"}], "]"}], "]"}]}], ";",
              "\[IndentingNewLine]", 
             RowBox[{"V", "=", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"V", "+", 
                 RowBox[{"Transpose", "[", "V", "]"}]}], ")"}], "/", "2"}]}], 
             ";", "\[IndentingNewLine]", 
             RowBox[{"iV", "=", 
              RowBox[{"Inverse", "[", "V", "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"mum", "=", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"kappa0", "/", 
                  RowBox[{"(", 
                   RowBox[{"kappa0", "+", "m"}], ")"}]}], ")"}], " ", "mu0"}],
                "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"m", "/", 
                  RowBox[{"(", 
                   RowBox[{"kappa0", "+", "m"}], ")"}]}], ")"}], " ", 
                "mbe"}]}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"kappam", "=", 
              RowBox[{"kappa0", "+", "m"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"Vk", "=", 
              RowBox[{"V", "/", "kappam"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"Vk", "=", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"Vk", "+", 
                 RowBox[{"Transpose", "[", "Vk", "]"}]}], ")"}], "/", "2"}]}],
              ";", "\[IndentingNewLine]", 
             RowBox[{"mu", "=", 
              RowBox[{"RandomReal", "[", 
               RowBox[{"MultinormalDistribution", "[", 
                RowBox[{"mum", ",", "Vk"}], "]"}], "]"}]}], ";"}]}], 
           "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"like2", "=", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"be", "[", 
                   RowBox[{"[", "sp", "]"}], "]"}], "-", "mu"}], ")"}], ".", 
                "iV", ".", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"be", "[", 
                   RowBox[{"[", "sp", "]"}], "]"}], "-", "mu"}], ")"}]}]}], 
              "/", "2"}], ",", 
             RowBox[{"{", 
              RowBox[{"sp", ",", "m"}], "}"}]}], "]"}]}], ";", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"update", "[", 
             RowBox[{"[", "4", "]"}], "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"(*", " ", 
             RowBox[{"update", " ", "e"}], " ", "*)"}], "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Do", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
                RowBox[{"ne", "=", "e"}], ";", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"ne", "[", 
                  RowBox[{"[", "cs", "]"}], "]"}], "+=", 
                 RowBox[{"Random", "[", 
                  RowBox[{"NormalDistribution", "[", 
                   RowBox[{"0", ",", 
                    RowBox[{"kke", "[", 
                    RowBox[{"[", "cs", "]"}], "]"}]}], "]"}], "]"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"nlike1", "=", 
                 RowBox[{"loglikesite", "[", 
                  RowBox[{"X", ",", "cs", ",", "be", ",", 
                   RowBox[{"ne", "[", 
                    RowBox[{"[", "cs", "]"}], "]"}], ",", "y"}], "]"}]}], ";",
                 "\[IndentingNewLine]", 
                RowBox[{"nlike3", "=", 
                 RowBox[{
                  RowBox[{"-", 
                   RowBox[{"ne", ".", "ne"}]}], "/", 
                  RowBox[{"(", "si2", ")"}]}]}], ";", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"ace", "[", 
                  RowBox[{"[", 
                   RowBox[{"cs", ",", "2"}], "]"}], "]"}], "+=", "1"}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"Random", "[", "]"}], "<", 
                   RowBox[{"Exp", "[", 
                    RowBox[{
                    RowBox[{"Total", "[", "nlike1", "]"}], "-", 
                    RowBox[{"Total", "[", 
                    RowBox[{"like1", "[", 
                    RowBox[{"[", 
                    RowBox[{"All", ",", "cs"}], "]"}], "]"}], "]"}], "+", 
                    "nlike3", "-", "like3"}], "]"}]}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"e", "=", "ne"}], ";", "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"like1", "[", 
                    RowBox[{"[", 
                    RowBox[{"All", ",", "cs"}], "]"}], "]"}], "=", "nlike1"}],
                    ";", "\[IndentingNewLine]", 
                   RowBox[{"like3", "=", "nlike3"}], ";", 
                   "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"ace", "[", 
                    RowBox[{"[", 
                    RowBox[{"cs", ",", "1"}], "]"}], "]"}], "+=", "1"}], 
                   ";"}]}], "\[IndentingNewLine]", "]"}], ";"}], 
               "\[IndentingNewLine]", ",", 
               RowBox[{"{", 
                RowBox[{"cs", ",", "n"}], "}"}]}], "]"}], ";"}]}], 
           "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{"Quiet", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"r", "=", 
             RowBox[{"N", "[", 
              RowBox[{
               RowBox[{"ac", "[", 
                RowBox[{"[", 
                 RowBox[{"All", ",", "1"}], "]"}], "]"}], "/", 
               RowBox[{"ac", "[", 
                RowBox[{"[", 
                 RowBox[{"All", ",", "2"}], "]"}], "]"}]}], "]"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"re", "=", 
             RowBox[{"N", "[", 
              RowBox[{
               RowBox[{"ace", "[", 
                RowBox[{"[", 
                 RowBox[{"All", ",", "1"}], "]"}], "]"}], "/", 
               RowBox[{"ace", "[", 
                RowBox[{"[", 
                 RowBox[{"All", ",", "2"}], "]"}], "]"}]}], "]"}]}], ";"}], 
           "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"zz", "<", "trans"}], ",", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"w", "=", 
              RowBox[{"1", "-", 
               RowBox[{"0.5", " ", 
                RowBox[{"N", "[", 
                 RowBox[{"Exp", "[", 
                  RowBox[{
                   RowBox[{"-", "zz"}], "/", "relax"}], "]"}], "]"}]}]}]}], 
             ";", "\[IndentingNewLine]", 
             RowBox[{"aa", "=", 
              RowBox[{"N", "[", 
               RowBox[{"Exp", "[", 
                RowBox[{
                 RowBox[{"-", "zz"}], "/", "relax"}], "]"}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"kk", "*=", 
              RowBox[{"Exp", "[", 
               RowBox[{"aa", 
                RowBox[{"(", 
                 RowBox[{"r", "-", "0.44"}], ")"}]}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"kke", "*=", 
              RowBox[{"Exp", "[", 
               RowBox[{"aa", 
                RowBox[{"(", 
                 RowBox[{"re", "-", "0.44"}], ")"}]}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"ac", "*=", "w"}], ";", "\[IndentingNewLine]", 
             RowBox[{"ace", "*=", "w"}], ";"}]}], "\[IndentingNewLine]", 
           "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"zz", "\[Equal]", "trans"}], ",", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"ta", "=", 
              RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"ac", "=", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"sp", ",", "m"}], "}"}]}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"ace", "=", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"i", ",", "n"}], "}"}]}], "]"}]}], ";"}]}], 
           "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Mod", "[", 
              RowBox[{"zz", ",", "thin"}], "]"}], "\[Equal]", "0"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"AppendTo", "[", 
              RowBox[{"ta", ",", 
               RowBox[{"{", 
                RowBox[{"mu", ",", "V", ",", "be", ",", "si2", ",", "e"}], 
                "}"}]}], "]"}], ";"}]}], "\[IndentingNewLine]", "]"}], ";"}], 
         "\[IndentingNewLine]", ",", 
         RowBox[{"{", 
          RowBox[{"zz", ",", 
           RowBox[{"trans", "+", "iter"}]}], "}"}]}], "]"}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{"ar", ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Print", "[", 
           RowBox[{"\"\<accept ratios for be: \>\"", ",", 
            RowBox[{"Sort", "[", 
             RowBox[{"N", "[", "r", "]"}], "]"}]}], "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"Print", "[", 
           RowBox[{"\"\<accept ratios for e: \>\"", ",", 
            RowBox[{"Sort", "[", 
             RowBox[{"N", "[", "re", "]"}], "]"}]}], "]"}], ";"}]}], 
        "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", "ta"}]}], 
     "\[IndentingNewLine]", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MCMCpars", "[", "p_", "]"}], ":=", 
   RowBox[{"MCMC", "[", 
    RowBox[{
     RowBox[{"p", "[", 
      RowBox[{"[", "1", "]"}], "]"}], ",", 
     RowBox[{"p", "[", 
      RowBox[{"[", "2", "]"}], "]"}], ",", 
     RowBox[{"p", "[", 
      RowBox[{"[", "3", "]"}], "]"}], ",", 
     RowBox[{"p", "[", 
      RowBox[{"[", "4", "]"}], "]"}], ",", 
     RowBox[{"p", "[", 
      RowBox[{"[", "5", "]"}], "]"}], ",", 
     RowBox[{"p", "[", 
      RowBox[{"[", "6", "]"}], "]"}], ",", 
     RowBox[{"p", "[", 
      RowBox[{"[", "7", "]"}], "]"}], ",", 
     RowBox[{"p", "[", 
      RowBox[{"[", "8", "]"}], "]"}], ",", 
     RowBox[{"p", "[", 
      RowBox[{"[", "9", "]"}], "]"}], ",", 
     RowBox[{"p", "[", 
      RowBox[{"[", "10", "]"}], "]"}], ",", 
     RowBox[{"p", "[", 
      RowBox[{"[", "11", "]"}], "]"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.4459250823392*^9, 3.4459250843204*^9}, {
   3.4459254532478*^9, 3.4459254541682*^9}, {3.4459304578616*^9, 
   3.4459304803568*^9}, {3.4459331169245996`*^9, 3.4459331241373997`*^9}, {
   3.446530476076273*^9, 3.446530507962673*^9}, {3.4466059860154*^9, 
   3.4466059901134*^9}, 3.4466353290382*^9, {3.446788387125*^9, 
   3.44678839490625*^9}, 3.4477671091504*^9, {3.4478107812598*^9, 
   3.447810791899*^9}, {3.4639806032821937`*^9, 3.4639806062617936`*^9}, {
   3.4639808024629936`*^9, 3.4639808368141937`*^9}, {3.4639810645897937`*^9, 
   3.463981067397794*^9}, {3.4639834499163933`*^9, 3.4639834518819933`*^9}, {
   3.4639836904527936`*^9, 3.4639837065051937`*^9}, {3.4639858816455936`*^9, 
   3.4639858876047935`*^9}, {3.4639859243895936`*^9, 
   3.4639859613615932`*^9}, {3.463985999048194*^9, 3.4639860859225936`*^9}, {
   3.4639864126467934`*^9, 3.4639864263903933`*^9}, {3.463986482971594*^9, 
   3.463986486606394*^9}, {3.4639865526255937`*^9, 3.4639865712519937`*^9}, {
   3.4639866337515936`*^9, 3.4639866778839936`*^9}, {3.4639867733403935`*^9, 
   3.4639867756803937`*^9}, {3.4639882875335937`*^9, 3.4639883063159933`*^9}, 
   3.4639883822743936`*^9, {3.4639884488239937`*^9, 3.4639884496039934`*^9}, {
   3.4639884837835937`*^9, 3.463988485795994*^9}, 3.4639887864079933`*^9, 
   3.4639889185399933`*^9, {3.4639980153328*^9, 3.4639980219472*^9}, {
   3.4639981610699997`*^9, 3.4639981813968*^9}, {3.4639996665948*^9, 
   3.4639996736772003`*^9}, {3.4639997271071997`*^9, 3.4639997274972*^9}, {
   3.463999759758*^9, 3.4639998564468*^9}, {3.4639998974592*^9, 
   3.4639999547268*^9}, {3.4640000188428*^9, 3.4640000216507998`*^9}, {
   3.464000060994*^9, 3.4640000618208*^9}, {3.4640010530254*^9, 
   3.4640010589066*^9}, {3.4640010907306004`*^9, 3.464001096409*^9}, 
   3.464001147109*^9, {3.4640011838157997`*^9, 3.4640011975282*^9}, {
   3.464001344449*^9, 3.4640013483178*^9}, {3.4640019569398003`*^9, 
   3.464002274119*^9}, {3.464008973914*^9, 3.4640093332132*^9}, {
   3.4640094116032*^9, 3.4640096190052*^9}, {3.464009772244*^9, 
   3.464009774818*^9}, {3.4640100193636*^9, 3.4640101326976*^9}, {
   3.4640101632111998`*^9, 3.4640101679068003`*^9}, {3.4640102361712*^9, 
   3.4640102720950003`*^9}, {3.4640105594384003`*^9, 3.4640105626208*^9}, 
   3.4640250368486*^9, 3.464025079031*^9, {3.4640257902892*^9, 
   3.4640257999456*^9}, {3.4640609277056*^9, 3.4640609375804*^9}, {
   3.4641142961228*^9, 3.4641142989776*^9}, {3.4641881577496*^9, 
   3.4641881725383997`*^9}, {3.4641884232492*^9, 3.4641886145364*^9}, {
   3.4641886493868*^9, 3.4641887614572*^9}, {3.4641887968691998`*^9, 
   3.4641889331196003`*^9}, 3.4641889637804003`*^9, {3.4641909753264*^9, 
   3.4641910102688*^9}, {3.464191043163*^9, 3.4641910499646*^9}, {
   3.4641910802286*^9, 3.464191280517*^9}, {3.4641913510559998`*^9, 
   3.4641913538484*^9}, {3.4641915438174*^9, 3.4641915498702*^9}, {
   3.4641921241284*^9, 3.464192128356*^9}, {3.4641931616898003`*^9, 
   3.464193171783*^9}, {3.4641937188126*^9, 3.4641937259262*^9}, 
   3.4641939064558*^9, {3.4641939867072*^9, 3.4641940112307997`*^9}, {
   3.4641940605318003`*^9, 3.4641942030378*^9}, {3.4641942344406*^9, 
   3.4641942410081997`*^9}, {3.4641943834124002`*^9, 3.464194404176*^9}, {
   3.4641946208444*^9, 3.4641946375208*^9}, {3.464194747301*^9, 
   3.4641947593129997`*^9}, {3.4641949608972*^9, 3.4641949912236*^9}, {
   3.4641950666496*^9, 3.4641950669147997`*^9}, {3.4641951234024*^9, 
   3.4641951245568*^9}, {3.4641951624336*^9, 3.4641951765516*^9}, {
   3.4641952092335997`*^9, 3.4641952165811996`*^9}, {3.464195450479*^9, 
   3.4641954898222*^9}, {3.4641955264978*^9, 3.4641955536730003`*^9}, {
   3.4641956768038*^9, 3.4641956773654003`*^9}, {3.4641959657938004`*^9, 
   3.4641959753254004`*^9}, {3.4641961452406*^9, 3.4641961510282*^9}, {
   3.4641964504052*^9, 3.464196576119*^9}, {3.4642801877595997`*^9, 
   3.4642801882432003`*^9}, {3.4643164294494*^9, 3.4643164436142*^9}, {
   3.4777182826392*^9, 3.4777182866484003`*^9}, {3.4777183221228*^9, 
   3.4777183301099997`*^9}, 3.4777189334016*^9, 3.4777189814652*^9, {
   3.4777190236788*^9, 3.4777192753848*^9}, 3.477719306928*^9, {
   3.4777193427144003`*^9, 3.4777194200903997`*^9}, {3.4777194505884*^9, 
   3.4777194915852003`*^9}, {3.4777195239084*^9, 3.4777195624716*^9}, {
   3.4777197763826*^9, 3.4777199640973997`*^9}, {3.4777296828059998`*^9, 
   3.4777297423199997`*^9}, 3.47773092496*^9, {3.477731004442*^9, 
   3.47773110631*^9}, {3.4777311458092003`*^9, 3.4777313069572*^9}, {
   3.4777313393222*^9, 3.477731367449*^9}, {3.4777314141614*^9, 
   3.4777314183733997`*^9}, {3.4777314794992*^9, 3.4777314814648*^9}, {
   3.477734643288625*^9, 3.477734679194875*^9}, {3.4777350012105*^9, 
   3.477735001819875*^9}, {3.47773526367925*^9, 3.47773526392925*^9}, {
   3.47774672467925*^9, 3.47774673574175*^9}, {3.47774679080425*^9, 
   3.47774682180425*^9}, {3.477746862601125*^9, 3.47774689817925*^9}, {
   3.47774693711675*^9, 3.477746938913625*^9}, {3.47774744042925*^9, 
   3.477747452648*^9}, {3.477747483257375*^9, 3.47774752580425*^9}, {
   3.477747660398*^9, 3.47774766261675*^9}, {3.47774775505425*^9, 
   3.477747756038625*^9}, 3.47774780586675*^9, 3.477747887757375*^9}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{
    RowBox[{
    "Import", "[", 
     "\"\<C:\\\\all stuff\\\\Mathematica\\\\janne \
soininen\\\\data\\\\data_abundance.xls\>\"", "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"species", "=", 
   RowBox[{"Drop", "[", 
    RowBox[{
     RowBox[{"data", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", "1"}], "]"}], "]"}], ",", "1"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sites", "=", 
   RowBox[{"Drop", "[", 
    RowBox[{
     RowBox[{"data", "[", 
      RowBox[{"[", "1", "]"}], "]"}], ",", "3"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"n", "=", 
   RowBox[{"Length", "[", "sites", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"Round", "[", 
    RowBox[{"Transpose", "[", 
     RowBox[{"Drop", "[", 
      RowBox[{"data", ",", "1", ",", "3"}], "]"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"yall", "=", 
   RowBox[{"Sign", "[", "data", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"yall", "=", 
   RowBox[{"Transpose", "[", 
    RowBox[{"Join", "[", 
     RowBox[{
      RowBox[{"Transpose", "[", "yall", "]"}], ",", 
      RowBox[{"Table", "[", 
       RowBox[{"0", ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "133"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"j", ",", "105"}], "}"}]}], "]"}]}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"m", "=", 
   RowBox[{"Length", "[", 
    RowBox[{"yall", "[", 
     RowBox[{"[", "1", "]"}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"m", ",", "\"\< species, \>\"", ",", "n", ",", "\"\< sites\>\""}],
     "]"}], ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"env", "=", 
   RowBox[{
    RowBox[{
    "Import", "[", 
     "\"\<C:\\\\all stuff\\\\Mathematica\\\\janne \
soininen\\\\data\\\\environment.xls\>\"", "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<sites in same order: \>\"", ",", 
    RowBox[{
     RowBox[{"Drop", "[", 
      RowBox[{
       RowBox[{"env", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "1"}], "]"}], "]"}], ",", "1"}], "]"}], 
     "\[Equal]", "sites"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"vars", "=", 
   RowBox[{"Drop", "[", 
    RowBox[{
     RowBox[{"env", "[", 
      RowBox[{"[", "1", "]"}], "]"}], ",", "1"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nv", "=", 
   RowBox[{"Length", "[", "vars", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"nv", ",", "\"\< environmental variables:\>\""}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"i", ",", 
       RowBox[{"vars", "[", 
        RowBox[{"[", "i", "]"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "nv"}], "}"}]}], "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"env", "=", 
    RowBox[{"Drop", "[", 
     RowBox[{"env", ",", "1", ",", "1"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"region", "=", 
   RowBox[{"env", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "11"}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"regions", "=", 
   RowBox[{"Union", "[", "region", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"indregion", "=", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"region", "[", 
          RowBox[{"[", "i", "]"}], "]"}], "\[Equal]", 
         RowBox[{"regions", "[", 
          RowBox[{"[", "j", "]"}], "]"}]}], ",", "1.", ",", "0"}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", 
        RowBox[{"Length", "[", "regions", "]"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "n"}], "}"}]}], "]"}]}], ";"}], " ", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "indicator", " ", "variable", " ", "telling", " ", "if", " ", "region", 
     " ", "is", " ", "1"}], ",", "2", ",", "3", ",", "4", ",", "5", ",", "6", 
    ",", "7"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"If", "[", 
   RowBox[{"False", ",", 
    RowBox[{"Do", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"indregion", "[", 
        RowBox[{"[", "i", "]"}], "]"}], "=", 
       RowBox[{"norm", "[", 
        RowBox[{"indregion", "[", 
         RowBox[{"[", "i", "]"}], "]"}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", 
        RowBox[{"Length", "[", "regions", "]"}]}], "}"}]}], "]"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"PC1", "=", 
   RowBox[{"norm", "[", 
    RowBox[{"env", "[", 
     RowBox[{"[", 
      RowBox[{"All", ",", "13"}], "]"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"PC2", "=", 
   RowBox[{"norm", "[", 
    RowBox[{"env", "[", 
     RowBox[{"[", 
      RowBox[{"All", ",", "14"}], "]"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Xall", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Join", "[", 
      RowBox[{
       RowBox[{"indregion", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "j"}], "]"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"PC1", "[", 
          RowBox[{"[", "j", "]"}], "]"}], ",", 
         RowBox[{"PC2", "[", 
          RowBox[{"[", "j", "]"}], "]"}], ",", 
         RowBox[{
          RowBox[{"PC1", "[", 
           RowBox[{"[", "j", "]"}], "]"}], "^", "2"}], ",", 
         RowBox[{
          RowBox[{"PC2", "[", 
           RowBox[{"[", "j", "]"}], "]"}], "^", "2"}]}], "}"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"j", ",", "n"}], "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"labels", "=", 
   RowBox[{"{", 
    RowBox[{
    "\"\<r1\>\"", ",", "\"\<r2\>\"", ",", "\"\<r3\>\"", ",", "\"\<r4\>\"", 
     ",", "\"\<r5\>\"", ",", "\"\<r6\>\"", ",", "\"\<r7\>\"", ",", 
     "\"\<PC1\>\"", ",", "\"\<PC2\>\"", ",", "\"\<PC1^2\>\"", ",", 
     "\"\<PC2^2\>\""}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"k", "=", 
   RowBox[{"Length", "[", "labels", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"k", ",", "\"\< covariates: \>\"", ",", "labels"}], "]"}], 
  ";"}]}], "Input",
 CellChangeTimes->{
  3.4465252295058727`*^9, {3.446525270284273*^9, 3.4465252888014727`*^9}, {
   3.446525321789873*^9, 3.446525372599073*^9}, {3.4465254357478733`*^9, 
   3.4465254519250727`*^9}, {3.446525483639873*^9, 3.4465254840610733`*^9}, {
   3.446525782784273*^9, 3.446525790303473*^9}, {3.4465258433590727`*^9, 
   3.446525843561873*^9}, 3.446788403734375*^9, {3.4478111811432*^9, 
   3.4478111844192*^9}, {3.4478114753556004`*^9, 3.4478114916888*^9}, {
   3.4478353350618*^9, 3.4478353414890003`*^9}, {3.4639806176809936`*^9, 
   3.463980635636594*^9}, {3.463981604307994*^9, 3.4639816045731936`*^9}, {
   3.463983514796794*^9, 3.4639835222223935`*^9}, {3.4639843017897935`*^9, 
   3.463984302725794*^9}, {3.463985098439994*^9, 3.4639851107483935`*^9}, {
   3.4641967384927998`*^9, 3.4641967905032*^9}, {3.4840209666156*^9, 
   3.4840210000464*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "500", "\[InvisibleSpace]", "\<\" species, \"\>", "\[InvisibleSpace]", 
   "105", "\[InvisibleSpace]", "\<\" sites\"\>"}],
  SequenceForm[500, " species, ", 105, " sites"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.446525374502273*^9, {3.4465254472450733`*^9, 3.446525454686273*^9}, 
   3.446525486213873*^9, 3.4465257916762733`*^9, 3.446525844809873*^9, 
   3.446527530465073*^9, 3.44655317867*^9, 3.4466059985094*^9, 
   3.4466352669034*^9, 3.4466353335934*^9, 3.44678840771875*^9, 
   3.44776707375*^9, 3.4477671129568*^9, 3.4478112355766*^9, {
   3.4478114795832*^9, 3.4478114936232*^9}, 3.4478352482790003`*^9, 
   3.4478353432362003`*^9, 3.4478355983862*^9, 3.447839062002*^9, 
   3.4478401100727997`*^9, 3.4636474816349416`*^9, 3.4639222001096*^9, 
   3.4639804011677933`*^9, {3.4639806094909935`*^9, 3.4639806368377934`*^9}, 
   3.4639807531045933`*^9, {3.4639815778765936`*^9, 3.4639816056027937`*^9}, 
   3.4639834633635936`*^9, 3.4639835320035934`*^9, 3.463983607413994*^9, 
   3.4639837099995937`*^9, {3.463984303895794*^9, 3.463984328262994*^9}, 
   3.463985138958194*^9, 3.4639858901943936`*^9, 3.4639859740599937`*^9, 
   3.4639860468153934`*^9, 3.4639860886369934`*^9, 3.4639864898979936`*^9, 
   3.4639866959331937`*^9, 3.463986784681594*^9, 3.4639884981979933`*^9, 
   3.4639890130759935`*^9, 3.4639890487219934`*^9, 3.4639977428008003`*^9, 
   3.4639999614035997`*^9, 3.4640000246772003`*^9, 3.4640011033354*^9, 
   3.4640022773638*^9, 3.4640093532904*^9, 3.4640096210488*^9, 
   3.4640101746772003`*^9, 3.4640102747314*^9, {3.4640105664584*^9, 
   3.4640105855684*^9}, 3.4640251063778*^9, 3.4641143472128*^9, 
   3.464188182538*^9, 3.4641931743726*^9, 3.464193916705*^9, 3.46419518184*^9,
    3.4641959905978003`*^9, 3.4641966733316*^9, 3.4641967929992*^9, 
   3.4642628620568*^9, 3.4642805471056004`*^9, 3.4643164897278*^9, 
   3.4777177317827997`*^9, 3.477717773934*^9, 3.4777199862026*^9, 
   3.4777297447692003`*^9, 3.4777298132532*^9, 3.477731310124*^9, 
   3.4777313716142*^9, 3.4777314335053997`*^9, 3.4777314841730003`*^9, 
   3.4777319040494003`*^9, 3.477734899882375*^9, 3.477735009319875*^9, 
   3.477746584882375*^9, 3.47774707380425*^9, 3.477747773726125*^9, 
   3.477747808507375*^9, 3.4777479010855*^9, 3.47774797655425*^9, {
   3.4840209556331997`*^9, 3.4840210008576*^9}, 3.484021242817*^9, 
   3.48402160809825*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"sites in same order: \"\>", "\[InvisibleSpace]", "True"}],
  SequenceForm["sites in same order: ", True],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.446525374502273*^9, {3.4465254472450733`*^9, 3.446525454686273*^9}, 
   3.446525486213873*^9, 3.4465257916762733`*^9, 3.446525844809873*^9, 
   3.446527530465073*^9, 3.44655317867*^9, 3.4466059985094*^9, 
   3.4466352669034*^9, 3.4466353335934*^9, 3.44678840771875*^9, 
   3.44776707375*^9, 3.4477671129568*^9, 3.4478112355766*^9, {
   3.4478114795832*^9, 3.4478114936232*^9}, 3.4478352482790003`*^9, 
   3.4478353432362003`*^9, 3.4478355983862*^9, 3.447839062002*^9, 
   3.4478401100727997`*^9, 3.4636474816349416`*^9, 3.4639222001096*^9, 
   3.4639804011677933`*^9, {3.4639806094909935`*^9, 3.4639806368377934`*^9}, 
   3.4639807531045933`*^9, {3.4639815778765936`*^9, 3.4639816056027937`*^9}, 
   3.4639834633635936`*^9, 3.4639835320035934`*^9, 3.463983607413994*^9, 
   3.4639837099995937`*^9, {3.463984303895794*^9, 3.463984328262994*^9}, 
   3.463985138958194*^9, 3.4639858901943936`*^9, 3.4639859740599937`*^9, 
   3.4639860468153934`*^9, 3.4639860886369934`*^9, 3.4639864898979936`*^9, 
   3.4639866959331937`*^9, 3.463986784681594*^9, 3.4639884981979933`*^9, 
   3.4639890130759935`*^9, 3.4639890487219934`*^9, 3.4639977428008003`*^9, 
   3.4639999614035997`*^9, 3.4640000246772003`*^9, 3.4640011033354*^9, 
   3.4640022773638*^9, 3.4640093532904*^9, 3.4640096210488*^9, 
   3.4640101746772003`*^9, 3.4640102747314*^9, {3.4640105664584*^9, 
   3.4640105855684*^9}, 3.4640251063778*^9, 3.4641143472128*^9, 
   3.464188182538*^9, 3.4641931743726*^9, 3.464193916705*^9, 3.46419518184*^9,
    3.4641959905978003`*^9, 3.4641966733316*^9, 3.4641967929992*^9, 
   3.4642628620568*^9, 3.4642805471056004`*^9, 3.4643164897278*^9, 
   3.4777177317827997`*^9, 3.477717773934*^9, 3.4777199862026*^9, 
   3.4777297447692003`*^9, 3.4777298132532*^9, 3.477731310124*^9, 
   3.4777313716142*^9, 3.4777314335053997`*^9, 3.4777314841730003`*^9, 
   3.4777319040494003`*^9, 3.477734899882375*^9, 3.477735009319875*^9, 
   3.477746584882375*^9, 3.47774707380425*^9, 3.477747773726125*^9, 
   3.477747808507375*^9, 3.4777479010855*^9, 3.47774797655425*^9, {
   3.4840209556331997`*^9, 3.4840210008576*^9}, 3.484021242817*^9, 
   3.484021608613875*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"15", "\[InvisibleSpace]", "\<\" environmental variables:\"\>"}],
  SequenceForm[15, " environmental variables:"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.446525374502273*^9, {3.4465254472450733`*^9, 3.446525454686273*^9}, 
   3.446525486213873*^9, 3.4465257916762733`*^9, 3.446525844809873*^9, 
   3.446527530465073*^9, 3.44655317867*^9, 3.4466059985094*^9, 
   3.4466352669034*^9, 3.4466353335934*^9, 3.44678840771875*^9, 
   3.44776707375*^9, 3.4477671129568*^9, 3.4478112355766*^9, {
   3.4478114795832*^9, 3.4478114936232*^9}, 3.4478352482790003`*^9, 
   3.4478353432362003`*^9, 3.4478355983862*^9, 3.447839062002*^9, 
   3.4478401100727997`*^9, 3.4636474816349416`*^9, 3.4639222001096*^9, 
   3.4639804011677933`*^9, {3.4639806094909935`*^9, 3.4639806368377934`*^9}, 
   3.4639807531045933`*^9, {3.4639815778765936`*^9, 3.4639816056027937`*^9}, 
   3.4639834633635936`*^9, 3.4639835320035934`*^9, 3.463983607413994*^9, 
   3.4639837099995937`*^9, {3.463984303895794*^9, 3.463984328262994*^9}, 
   3.463985138958194*^9, 3.4639858901943936`*^9, 3.4639859740599937`*^9, 
   3.4639860468153934`*^9, 3.4639860886369934`*^9, 3.4639864898979936`*^9, 
   3.4639866959331937`*^9, 3.463986784681594*^9, 3.4639884981979933`*^9, 
   3.4639890130759935`*^9, 3.4639890487219934`*^9, 3.4639977428008003`*^9, 
   3.4639999614035997`*^9, 3.4640000246772003`*^9, 3.4640011033354*^9, 
   3.4640022773638*^9, 3.4640093532904*^9, 3.4640096210488*^9, 
   3.4640101746772003`*^9, 3.4640102747314*^9, {3.4640105664584*^9, 
   3.4640105855684*^9}, 3.4640251063778*^9, 3.4641143472128*^9, 
   3.464188182538*^9, 3.4641931743726*^9, 3.464193916705*^9, 3.46419518184*^9,
    3.4641959905978003`*^9, 3.4641966733316*^9, 3.4641967929992*^9, 
   3.4642628620568*^9, 3.4642805471056004`*^9, 3.4643164897278*^9, 
   3.4777177317827997`*^9, 3.477717773934*^9, 3.4777199862026*^9, 
   3.4777297447692003`*^9, 3.4777298132532*^9, 3.477731310124*^9, 
   3.4777313716142*^9, 3.4777314335053997`*^9, 3.4777314841730003`*^9, 
   3.4777319040494003`*^9, 3.477734899882375*^9, 3.477735009319875*^9, 
   3.477746584882375*^9, 3.47774707380425*^9, 3.477747773726125*^9, 
   3.477747808507375*^9, 3.4777479010855*^9, 3.47774797655425*^9, {
   3.4840209556331997`*^9, 3.4840210008576*^9}, 3.484021242817*^9, 
   3.4840216086295*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "\<\"shading\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "\<\"particle\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "\<\"mosscove\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", "\<\"watervel\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", "\<\"conducta\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"6", ",", "\<\"ph\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"7", ",", "\<\"colour\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"8", ",", "\<\"totP\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"9", ",", "\<\"lat\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"10", ",", "\<\"long\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"11", ",", "\<\"Region\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"12", ",", "\<\"evenness\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"13", ",", "\<\"PC1\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"14", ",", "\<\"PC2\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"15", ",", "\<\"grazers\"\>"}], "}"}]}], "}"}]], "Print",
 CellChangeTimes->{
  3.446525374502273*^9, {3.4465254472450733`*^9, 3.446525454686273*^9}, 
   3.446525486213873*^9, 3.4465257916762733`*^9, 3.446525844809873*^9, 
   3.446527530465073*^9, 3.44655317867*^9, 3.4466059985094*^9, 
   3.4466352669034*^9, 3.4466353335934*^9, 3.44678840771875*^9, 
   3.44776707375*^9, 3.4477671129568*^9, 3.4478112355766*^9, {
   3.4478114795832*^9, 3.4478114936232*^9}, 3.4478352482790003`*^9, 
   3.4478353432362003`*^9, 3.4478355983862*^9, 3.447839062002*^9, 
   3.4478401100727997`*^9, 3.4636474816349416`*^9, 3.4639222001096*^9, 
   3.4639804011677933`*^9, {3.4639806094909935`*^9, 3.4639806368377934`*^9}, 
   3.4639807531045933`*^9, {3.4639815778765936`*^9, 3.4639816056027937`*^9}, 
   3.4639834633635936`*^9, 3.4639835320035934`*^9, 3.463983607413994*^9, 
   3.4639837099995937`*^9, {3.463984303895794*^9, 3.463984328262994*^9}, 
   3.463985138958194*^9, 3.4639858901943936`*^9, 3.4639859740599937`*^9, 
   3.4639860468153934`*^9, 3.4639860886369934`*^9, 3.4639864898979936`*^9, 
   3.4639866959331937`*^9, 3.463986784681594*^9, 3.4639884981979933`*^9, 
   3.4639890130759935`*^9, 3.4639890487219934`*^9, 3.4639977428008003`*^9, 
   3.4639999614035997`*^9, 3.4640000246772003`*^9, 3.4640011033354*^9, 
   3.4640022773638*^9, 3.4640093532904*^9, 3.4640096210488*^9, 
   3.4640101746772003`*^9, 3.4640102747314*^9, {3.4640105664584*^9, 
   3.4640105855684*^9}, 3.4640251063778*^9, 3.4641143472128*^9, 
   3.464188182538*^9, 3.4641931743726*^9, 3.464193916705*^9, 3.46419518184*^9,
    3.4641959905978003`*^9, 3.4641966733316*^9, 3.4641967929992*^9, 
   3.4642628620568*^9, 3.4642805471056004`*^9, 3.4643164897278*^9, 
   3.4777177317827997`*^9, 3.477717773934*^9, 3.4777199862026*^9, 
   3.4777297447692003`*^9, 3.4777298132532*^9, 3.477731310124*^9, 
   3.4777313716142*^9, 3.4777314335053997`*^9, 3.4777314841730003`*^9, 
   3.4777319040494003`*^9, 3.477734899882375*^9, 3.477735009319875*^9, 
   3.477746584882375*^9, 3.47774707380425*^9, 3.477747773726125*^9, 
   3.477747808507375*^9, 3.4777479010855*^9, 3.47774797655425*^9, {
   3.4840209556331997`*^9, 3.4840210008576*^9}, 3.484021242817*^9, 
   3.484021608645125*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "11", "\[InvisibleSpace]", "\<\" covariates: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"\<\"r1\"\>", ",", "\<\"r2\"\>", ",", "\<\"r3\"\>", 
     ",", "\<\"r4\"\>", ",", "\<\"r5\"\>", ",", "\<\"r6\"\>", 
     ",", "\<\"r7\"\>", ",", "\<\"PC1\"\>", ",", "\<\"PC2\"\>", 
     ",", "\<\"PC1^2\"\>", ",", "\<\"PC2^2\"\>"}], "}"}]}],
  SequenceForm[
  11, " covariates: ", {
   "r1", "r2", "r3", "r4", "r5", "r6", "r7", "PC1", "PC2", "PC1^2", "PC2^2"}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.446525374502273*^9, {3.4465254472450733`*^9, 3.446525454686273*^9}, 
   3.446525486213873*^9, 3.4465257916762733`*^9, 3.446525844809873*^9, 
   3.446527530465073*^9, 3.44655317867*^9, 3.4466059985094*^9, 
   3.4466352669034*^9, 3.4466353335934*^9, 3.44678840771875*^9, 
   3.44776707375*^9, 3.4477671129568*^9, 3.4478112355766*^9, {
   3.4478114795832*^9, 3.4478114936232*^9}, 3.4478352482790003`*^9, 
   3.4478353432362003`*^9, 3.4478355983862*^9, 3.447839062002*^9, 
   3.4478401100727997`*^9, 3.4636474816349416`*^9, 3.4639222001096*^9, 
   3.4639804011677933`*^9, {3.4639806094909935`*^9, 3.4639806368377934`*^9}, 
   3.4639807531045933`*^9, {3.4639815778765936`*^9, 3.4639816056027937`*^9}, 
   3.4639834633635936`*^9, 3.4639835320035934`*^9, 3.463983607413994*^9, 
   3.4639837099995937`*^9, {3.463984303895794*^9, 3.463984328262994*^9}, 
   3.463985138958194*^9, 3.4639858901943936`*^9, 3.4639859740599937`*^9, 
   3.4639860468153934`*^9, 3.4639860886369934`*^9, 3.4639864898979936`*^9, 
   3.4639866959331937`*^9, 3.463986784681594*^9, 3.4639884981979933`*^9, 
   3.4639890130759935`*^9, 3.4639890487219934`*^9, 3.4639977428008003`*^9, 
   3.4639999614035997`*^9, 3.4640000246772003`*^9, 3.4640011033354*^9, 
   3.4640022773638*^9, 3.4640093532904*^9, 3.4640096210488*^9, 
   3.4640101746772003`*^9, 3.4640102747314*^9, {3.4640105664584*^9, 
   3.4640105855684*^9}, 3.4640251063778*^9, 3.4641143472128*^9, 
   3.464188182538*^9, 3.4641931743726*^9, 3.464193916705*^9, 3.46419518184*^9,
    3.4641959905978003`*^9, 3.4641966733316*^9, 3.4641967929992*^9, 
   3.4642628620568*^9, 3.4642805471056004`*^9, 3.4643164897278*^9, 
   3.4777177317827997`*^9, 3.477717773934*^9, 3.4777199862026*^9, 
   3.4777297447692003`*^9, 3.4777298132532*^9, 3.477731310124*^9, 
   3.4777313716142*^9, 3.4777314335053997`*^9, 3.4777314841730003`*^9, 
   3.4777319040494003`*^9, 3.477734899882375*^9, 3.477735009319875*^9, 
   3.477746584882375*^9, 3.47774707380425*^9, 3.477747773726125*^9, 
   3.477747808507375*^9, 3.4777479010855*^9, 3.47774797655425*^9, {
   3.4840209556331997`*^9, 3.4840210008576*^9}, 3.484021242817*^9, 
   3.48402160866075*^9}]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"DistributeDefinitions", "[", 
   RowBox[{
   "MCMC", ",", "MCMCpars", ",", "ilogit", ",", "loglike", ",", 
    "loglikesite"}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.47773491292925*^9, 3.477734914601125*^9}, 
   3.47773501117925*^9, {3.477735270101125*^9, 3.47773527299175*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"thinspecies", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"thinsite", "=", "3"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nlist", "=", 
   RowBox[{"Table", "[", 
    RowBox[{"i", ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", "n", ",", "thinsite"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mlist", "=", 
   RowBox[{"Table", "[", 
    RowBox[{"i", ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", "m", ",", "thinspecies"}], "}"}]}], "]"}]}],
   ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"y", "=", 
   RowBox[{"yall", "[", 
    RowBox[{"[", 
     RowBox[{"nlist", ",", "mlist"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"X", "=", 
   RowBox[{"Xall", "[", 
    RowBox[{"[", "nlist", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<data thinned to \>\"", ",", 
    RowBox[{"Dimensions", "[", "y", "]"}], ",", "\"\<{sites, species}\>\""}], 
   "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
    RowBox[{"m", "-", 
     RowBox[{"Count", "[", 
      RowBox[{
       RowBox[{"Total", "[", "y", "]"}], ",", "0"}], "]"}]}], ",", 
    "\"\< species with >0 observations\>\""}], "]"}], ";"}]}], "Input",
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmViYGAQA2IQvSnahJX9/EtHl1vmYJppzncZEK0y8x+YNs+crg6i
/6TPAtPvrDTCQLSMlRaYZlk6tRNE/2d8DaYXMftPB6v/kQGmb0mvUeEF0hr8
p8G0xbWl3iBa7cluHxDdvvx5OIieFDMvAkSL3Qyz5gPSGZtf2YDoN/MyVPiB
tKhsLpj2S7rSBKLf8i5qBtE/F9RvBNEW6TVbQPTKJW0XhYD0K5YrYNpHdE60
MJDu/nsVTE96u6FJCkiHR98F003FrzpA9LptdZ0g2m3KvMUgeqXwAjA94dDD
PVJg+233gmifE91zpYH0tbAb80H0uY5910G0KttRMF2+773tdCA9U2uCA4gG
ALGEtHE=
  "]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"data thinned to \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"35", ",", "500"}], "}"}], 
   "\[InvisibleSpace]", "\<\"{sites, species}\"\>"}],
  SequenceForm["data thinned to ", {35, 500}, "{sites, species}"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.4639851939793935`*^9, 3.463985384174594*^9, 3.4639854702603936`*^9, 
   3.4639858415847936`*^9, 3.4639858909431934`*^9, 3.4639859751363935`*^9, 
   3.4639860500133934`*^9, 3.463986089838194*^9, {3.4639862534407935`*^9, 
   3.4639862555623937`*^9}, 3.4639863634987936`*^9, 3.4639864912083936`*^9, 
   3.4639866968223934`*^9, 3.4639884989935937`*^9, 3.4639890154783936`*^9, 
   3.463989049408394*^9, 3.463997745094*^9, {3.4639980456972*^9, 
   3.4639980542616*^9}, {3.4639981447992*^9, 3.4639981649388*^9}, {
   3.4639999649604*^9, 3.463999975584*^9}, 3.4640000264088*^9, 
   3.4640011066582003`*^9, 3.4640018278778*^9, 3.4640022792046003`*^9, {
   3.464002584899*^9, 3.4640025892826*^9}, {3.4640029566124*^9, 
   3.464002980262*^9}, 3.4640093592496*^9, 3.4640096217976*^9, 
   3.4640101754416*^9, {3.4640102473719997`*^9, 3.4640102755114*^9}, 
   3.4640104628900003`*^9, {3.4640105671916*^9, 3.4640105863171997`*^9}, 
   3.4640251111514*^9, {3.4640251599038*^9, 3.4640251641626*^9}, 
   3.4640253732676*^9, 3.4640255781438*^9, {3.4640273758782*^9, 
   3.4640273910102*^9}, 3.4640278384846*^9, 3.4641143479616003`*^9, 
   3.4641881843632*^9, 3.464193175059*^9, 3.4641939181246*^9, 
   3.464195183322*^9, 3.4641954058786*^9, 3.464195992033*^9, 
   3.4641968024372*^9, 3.4642628663780003`*^9, {3.4642805493052*^9, 
   3.4642805807548*^9}, 3.4643164934561996`*^9, 3.4777177391772003`*^9, 
   3.4777177772567997`*^9, 3.4777199906174*^9, 3.4777297455804*^9, 
   3.4777298138772*^9, 3.4777313118087997`*^9, 3.4777313723473997`*^9, 
   3.4777314341605997`*^9, 3.4777314848438*^9, 3.4777319046734*^9, 
   3.477735016319875*^9, 3.477746592382375*^9, 3.47774708049175*^9, 
   3.47774777642925*^9, 3.477747904819875*^9, 3.47774798161675*^9, 
   3.4840210165512*^9, 3.484021247238875*^9, 3.48402161209825*^9, 
   3.48402178147325*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "280", "\[InvisibleSpace]", "\<\" species with >0 observations\"\>"}],
  SequenceForm[280, " species with >0 observations"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.4639851939793935`*^9, 3.463985384174594*^9, 3.4639854702603936`*^9, 
   3.4639858415847936`*^9, 3.4639858909431934`*^9, 3.4639859751363935`*^9, 
   3.4639860500133934`*^9, 3.463986089838194*^9, {3.4639862534407935`*^9, 
   3.4639862555623937`*^9}, 3.4639863634987936`*^9, 3.4639864912083936`*^9, 
   3.4639866968223934`*^9, 3.4639884989935937`*^9, 3.4639890154783936`*^9, 
   3.463989049408394*^9, 3.463997745094*^9, {3.4639980456972*^9, 
   3.4639980542616*^9}, {3.4639981447992*^9, 3.4639981649388*^9}, {
   3.4639999649604*^9, 3.463999975584*^9}, 3.4640000264088*^9, 
   3.4640011066582003`*^9, 3.4640018278778*^9, 3.4640022792046003`*^9, {
   3.464002584899*^9, 3.4640025892826*^9}, {3.4640029566124*^9, 
   3.464002980262*^9}, 3.4640093592496*^9, 3.4640096217976*^9, 
   3.4640101754416*^9, {3.4640102473719997`*^9, 3.4640102755114*^9}, 
   3.4640104628900003`*^9, {3.4640105671916*^9, 3.4640105863171997`*^9}, 
   3.4640251111514*^9, {3.4640251599038*^9, 3.4640251641626*^9}, 
   3.4640253732676*^9, 3.4640255781438*^9, {3.4640273758782*^9, 
   3.4640273910102*^9}, 3.4640278384846*^9, 3.4641143479616003`*^9, 
   3.4641881843632*^9, 3.464193175059*^9, 3.4641939181246*^9, 
   3.464195183322*^9, 3.4641954058786*^9, 3.464195992033*^9, 
   3.4641968024372*^9, 3.4642628663780003`*^9, {3.4642805493052*^9, 
   3.4642805807548*^9}, 3.4643164934561996`*^9, 3.4777177391772003`*^9, 
   3.4777177772567997`*^9, 3.4777199906174*^9, 3.4777297455804*^9, 
   3.4777298138772*^9, 3.4777313118087997`*^9, 3.4777313723473997`*^9, 
   3.4777314341605997`*^9, 3.4777314848438*^9, 3.4777319046734*^9, 
   3.477735016319875*^9, 3.477746592382375*^9, 3.47774708049175*^9, 
   3.47774777642925*^9, 3.477747904819875*^9, 3.47774798161675*^9, 
   3.4840210165512*^9, 3.484021247238875*^9, 3.48402161209825*^9, 
   3.48402178147325*^9}]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"SET", " ", "PRIORS"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"PRI", "=", "1"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"PRI", "\[Equal]", "1"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"mu0", "=", 
        RowBox[{"Table", "[", 
         RowBox[{"0", ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "k"}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Lambda0", "=", 
        RowBox[{"IdentityMatrix", "[", "k", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"kappa0", "=", "0"}], ";", "\[IndentingNewLine]", 
       RowBox[{"nu0", "=", "k"}], ";", "\[IndentingNewLine]", 
       RowBox[{"primuV", "=", 
        RowBox[{"{", 
         RowBox[{"mu0", ",", "Lambda0", ",", "kappa0", ",", "nu0"}], "}"}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"si02", "=", "1"}], ";", "\[IndentingNewLine]", 
       RowBox[{"nu0", "=", "1"}], ";", "\[IndentingNewLine]", 
       RowBox[{"prisi2", "=", 
        RowBox[{"{", 
         RowBox[{"si02", ",", "nu0"}], "}"}]}], ";"}]}], 
     "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"PRI", "\[Equal]", "2"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"mu0", "=", 
        RowBox[{"Table", "[", 
         RowBox[{"0", ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "k"}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Lambda0", "=", 
        RowBox[{"IdentityMatrix", "[", "k", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"kappa0", "=", "5"}], ";", "\[IndentingNewLine]", 
       RowBox[{"nu0", "=", 
        RowBox[{"k", "+", "5"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"primuV", "=", 
        RowBox[{"{", 
         RowBox[{"mu0", ",", "Lambda0", ",", "kappa0", ",", "nu0"}], "}"}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"si02", "=", "1"}], ";", "\[IndentingNewLine]", 
       RowBox[{"nu0", "=", "1"}], ";", "\[IndentingNewLine]", 
       RowBox[{"prisi2", "=", 
        RowBox[{"{", 
         RowBox[{"si02", ",", "nu0"}], "}"}]}], ";"}]}], 
     "\[IndentingNewLine]", "]"}], ";"}]}]}]], "Input",
 CellChangeTimes->{{3.4777309392028*^9, 3.477730970902*^9}, {
   3.4777313182516003`*^9, 3.477731321512*^9}, {3.4777342630601997`*^9, 
   3.4777342822094*^9}, {3.4777479077105*^9, 3.47774791830425*^9}, {
   3.4777489123355*^9, 3.477748916913625*^9}, {3.477748950476125*^9, 
   3.477748987382375*^9}, {3.4777491182105*^9, 3.4777491344605*^9}, {
   3.47775114717925*^9, 3.477751147226125*^9}, 3.477751633194875*^9, {
   3.47780007905425*^9, 3.47780010436675*^9}, {3.4778068189605*^9, 
   3.477806819101125*^9}, {3.477822132398*^9, 3.477822135601125*^9}, {
   3.477882583663625*^9, 3.477882608944875*^9}, {3.47788453874175*^9, 
   3.477884567273*^9}, {3.48402178328575*^9, 3.484021794613875*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"with", " ", "8", " ", "cores"}], ",", " ", 
    RowBox[{"0.5", " ", "seconds", " ", "per", " ", "iteration"}], ",", " ", 
    RowBox[{
    "including", " ", "full", " ", "model", " ", "and", " ", "the", " ", 
     "500", " ", "independent", " ", "models"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"relax", "=", "500"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"b", "=", 
     RowBox[{"N", "[", 
      RowBox[{"Map", "[", 
       RowBox[{"logit", ",", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Total", "[", "y", "]"}], "+", "1"}], ")"}], "/", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Length", "[", "nlist", "]"}], "+", "1"}], ")"}]}]}], 
       "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"be0", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"b", "[", 
            RowBox[{"[", "i", "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"j", ",", "7"}], "}"}]}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{"0", ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", 
             RowBox[{"k", "-", "7"}]}], "}"}]}], "]"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "m"}], "}"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"trans", "=", "50000"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"iter", "=", "150000"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"thin", "=", 
     RowBox[{"Max", "[", 
      RowBox[{
       RowBox[{"Round", "[", 
        RowBox[{"iter", "/", "100"}], "]"}], ",", "1"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"parsF", "=", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{
       "trans", ",", "iter", ",", "X", ",", "y", ",", "primuV", ",", "prisi2",
         ",", "thin", ",", "relax", ",", 
        RowBox[{"{", 
         RowBox[{"True", ",", "True", ",", "True", ",", "True"}], "}"}], ",", 
        "True", ",", "be0"}], "}"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"thin", "=", 
     RowBox[{"Max", "[", 
      RowBox[{
       RowBox[{"Round", "[", 
        RowBox[{"iter", "/", "100"}], "]"}], ",", "1"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"parsI", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"trans", ",", "iter", ",", "X", ",", 
         RowBox[{"y", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", 
            RowBox[{"{", "i", "}"}]}], "]"}], "]"}], ",", "primuV", ",", 
         "prisi2", ",", "thin", ",", "relax", ",", 
         RowBox[{"{", 
          RowBox[{"True", ",", "True", ",", "True", ",", "True"}], "}"}], ",", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Mod", "[", 
             RowBox[{"i", ",", "50"}], "]"}], "\[Equal]", "0"}], ",", "True", 
           ",", "False"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"be0", "[", 
           RowBox[{"[", "i", "]"}], "]"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "m"}], "}"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"pars", "=", 
     RowBox[{"Join", "[", 
      RowBox[{"parsF", ",", "parsI"}], "]"}]}], ";"}]}]}]], "Input",
 CellChangeTimes->{{3.4777350549605*^9, 3.47773505605425*^9}, {
   3.477735476023*^9, 3.4777356424605*^9}, {3.4777356905855*^9, 
   3.477735692851125*^9}, {3.477735745007375*^9, 3.47773578980425*^9}, {
   3.477746646507375*^9, 3.47774664967925*^9}, {3.477746743476125*^9, 
   3.47774676261675*^9}, {3.477746806913625*^9, 3.477746807023*^9}, 
   3.477747013101125*^9, {3.477747172273*^9, 3.477747180523*^9}, {
   3.477747238476125*^9, 3.477747255413625*^9}, {3.47774734092925*^9, 
   3.477747407226125*^9}, 3.47774781524175*^9, {3.477747931132375*^9, 
   3.477747931523*^9}, {3.477748266788625*^9, 3.477748286648*^9}, {
   3.47774833755425*^9, 3.47774834542925*^9}, {3.47775115411675*^9, 
   3.477751155538625*^9}, {3.477751208976125*^9, 3.47775120955425*^9}, {
   3.477751654382375*^9, 3.4777516669605*^9}, {3.47780011549175*^9, 
   3.477800116694875*^9}, {3.47780682255425*^9, 3.477806823148*^9}, {
   3.477825350038625*^9, 3.477825350523*^9}, {3.47788261805425*^9, 
   3.47788262592925*^9}, 3.47788457617925*^9, {3.4840210354896*^9, 
   3.4840210393115997`*^9}, {3.4840211243316*^9, 3.4840211315076*^9}, {
   3.484021760582625*^9, 3.484021776567*^9}, {3.48402183084825*^9, 
   3.48402183134825*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Quiet", "[", 
  RowBox[{"AbsoluteTiming", "[", 
   RowBox[{
    RowBox[{"tass", "=", 
     RowBox[{"ParallelMap", "[", 
      RowBox[{"MCMCpars", ",", "pars"}], "]"}]}], ";"}], "]"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.47774829724175*^9, 3.477748301898*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"14.9375`8.625822911788182", ",", "Null"}], "}"}]], "Output",
 CellChangeTimes->{3.4840210493892*^9, 3.4840211564832*^9, 
  3.484021266613875*^9, 3.484021631020125*^9, 3.484021816082625*^9}]
}, Open  ]]
},
WindowSize->{1424, 765},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
ShowSelection->True,
FrontEndVersion->"7.0 for Microsoft Windows (64-bit) (February 18, 2009)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[545, 20, 33346, 775, 2972, "Input"],
Cell[CellGroupData[{
Cell[33916, 799, 7513, 219, 572, "Input"],
Cell[CellGroupData[{
Cell[41454, 1022, 2412, 38, 23, "Print"],
Cell[43869, 1062, 2348, 36, 23, "Print"],
Cell[46220, 1100, 2350, 36, 23, "Print"],
Cell[48573, 1138, 3297, 64, 23, "Print"],
Cell[51873, 1204, 2703, 44, 23, "Print"]
}, Open  ]]
}, Open  ]],
Cell[54603, 1252, 321, 7, 31, "Input"],
Cell[CellGroupData[{
Cell[54949, 1263, 1758, 50, 172, "Input"],
Cell[CellGroupData[{
Cell[56732, 1317, 2146, 35, 23, "Print"],
Cell[58881, 1354, 2046, 33, 23, "Print"]
}, Open  ]]
}, Open  ]],
Cell[60954, 1391, 3060, 70, 472, "Input"],
Cell[64017, 1463, 4785, 121, 272, "Input"],
Cell[CellGroupData[{
Cell[68827, 1588, 289, 8, 31, "Input"],
Cell[69119, 1598, 229, 4, 30, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

