(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     68027,       1680]
NotebookOptionsPosition[     67261,       1652]
NotebookOutlinePosition[     67667,       1669]
CellTagsIndexPosition[     67624,       1666]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[{
 RowBox[{
  RowBox[{"Needs", "[", "\"\<MultivariateStatistics`\>\"", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Needs", "[", "\"\<ErrorBarPlots`\>\"", "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ilogit", "[", "x_", "]"}], ":=", 
   RowBox[{
    RowBox[{"Exp", "[", "x", "]"}], "/", 
    RowBox[{"(", 
     RowBox[{"1", "+", 
      RowBox[{"Exp", "[", "x", "]"}]}], ")"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"logit", "[", "x_", "]"}], ":=", 
    RowBox[{"Log", "[", 
     RowBox[{"x", "/", 
      RowBox[{"(", 
       RowBox[{"1", "-", "x"}], ")"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"loglike", "[", 
     RowBox[{"X_", ",", "sp_", ",", "be_", ",", "padata_"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "tn", "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"tn", "=", 
        RowBox[{"ilogit", "[", 
         RowBox[{"X", ".", "be"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Log", "[", 
        RowBox[{
         RowBox[{"tn", "*", 
          RowBox[{"padata", "[", 
           RowBox[{"[", 
            RowBox[{"All", ",", "sp"}], "]"}], "]"}]}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"1", "-", "tn"}], ")"}], "*", 
          RowBox[{"(", 
           RowBox[{"1", "-", 
            RowBox[{"padata", "[", 
             RowBox[{"[", 
              RowBox[{"All", ",", "sp"}], "]"}], "]"}]}], ")"}]}]}], 
        "]"}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"EllipsePlot", "[", 
     RowBox[{"ta_", ",", "options_"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"re", ",", "f1", ",", "el", ",", "ci", ",", "f2"}], "}"}], ",",
       "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"re", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"EllipsoidQuantile", "[", 
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"ta", "[", 
               RowBox[{"[", 
                RowBox[{"j", ",", "i"}], "]"}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"j", ",", "1", ",", 
                RowBox[{"Length", "[", "ta", "]"}], ",", 
                RowBox[{"Round", "[", 
                 RowBox[{
                  RowBox[{"Length", "[", "ta", "]"}], "/", "50"}], "]"}]}], 
               "}"}]}], "]"}], ",", "0.75"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", 
            RowBox[{"Length", "[", 
             RowBox[{"ta", "[", 
              RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"f1", "=", 
        RowBox[{"Graphics", "[", "re", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"ci", "=", "options"}], ";", "\[IndentingNewLine]", 
       RowBox[{"Do", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"el", "=", 
           RowBox[{"re", "[", 
            RowBox[{"[", "i", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"AppendTo", "[", 
           RowBox[{"ci", ",", 
            RowBox[{"Rotate", "[", 
             RowBox[{
              RowBox[{"Circle", "[", 
               RowBox[{
                RowBox[{"el", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], ",", 
                RowBox[{"el", "[", 
                 RowBox[{"[", "2", "]"}], "]"}]}], "]"}], ",", 
              RowBox[{"ArcTan", "[", 
               RowBox[{
                RowBox[{"el", "[", 
                 RowBox[{"[", 
                  RowBox[{"3", ",", "1", ",", "2"}], "]"}], "]"}], "/", 
                RowBox[{"el", "[", 
                 RowBox[{"[", 
                  RowBox[{"3", ",", "1", ",", "1"}], "]"}], "]"}]}], "]"}]}], 
             "]"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"i", ",", 
           RowBox[{"Length", "[", "re", "]"}]}], "}"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"f2", "=", 
        RowBox[{"Graphics", "[", "ci", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"f2", ",", "f1"}], "}"}]}]}], "\[IndentingNewLine]", "]"}]}], 
   ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"MCMC", "[", 
     RowBox[{
     "trans_", ",", "iter_", ",", "X_", ",", "y_", ",", "primuV_", ",", 
      "thin_", ",", "relax_", ",", "update_", ",", "ar_", ",", "be0_", ",", 
      "nmixt_"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "n", ",", "m", ",", "k", ",", "V", ",", "iV", ",", "be", ",", "mu", 
        ",", "like1", ",", "like2", ",", "ac", ",", "kk", ",", "ta", ",", 
        "nbe", ",", "nlike1", ",", "nlike2", ",", "si02", ",", "nu0", ",", 
        "nuS", ",", "v", ",", "siS2", ",", "mu0", ",", "Lambda0", ",", 
        "kappa0", ",", "mbe", ",", "S", ",", "num", ",", "Lambdam", ",", 
        "iLambdam", ",", "mum", ",", "kappam", ",", "r", ",", "w", ",", "aa", 
        ",", "Vk", ",", "f", ",", "model", ",", "ota", ",", "li1", ",", 
        "li2"}], "}"}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"n", ",", "m"}], "}"}], "=", 
        RowBox[{"Dimensions", "[", "y", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"n", ",", "k"}], "}"}], "=", 
        RowBox[{"Dimensions", "[", "X", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"f", "=", "0.5"}], ";", "\[IndentingNewLine]", 
       RowBox[{"model", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"RandomInteger", "[", 
           RowBox[{"{", 
            RowBox[{"1", ",", "nmixt"}], "}"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "m"}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"V", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"IdentityMatrix", "[", "k", "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "nmixt"}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"iV", "=", 
        RowBox[{"Map", "[", 
         RowBox[{"Inverse", ",", "V"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"be", "=", "be0"}], ";", "\[IndentingNewLine]", 
       RowBox[{"mu", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"Mean", "[", "be", "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "nmixt"}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"like1", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"loglike", "[", 
           RowBox[{"X", ",", "sp", ",", 
            RowBox[{"be", "[", 
             RowBox[{"[", "sp", "]"}], "]"}], ",", "y"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"sp", ",", "m"}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"like2", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"be", "[", 
                RowBox[{"[", "sp", "]"}], "]"}], "-", 
               RowBox[{"mu", "[", 
                RowBox[{"[", 
                 RowBox[{"model", "[", 
                  RowBox[{"[", "sp", "]"}], "]"}], "]"}], "]"}]}], ")"}], ".", 
             RowBox[{"iV", "[", 
              RowBox[{"[", 
               RowBox[{"model", "[", 
                RowBox[{"[", "sp", "]"}], "]"}], "]"}], "]"}], ".", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"be", "[", 
                RowBox[{"[", "sp", "]"}], "]"}], "-", 
               RowBox[{"mu", "[", 
                RowBox[{"[", 
                 RowBox[{"model", "[", 
                  RowBox[{"[", "sp", "]"}], "]"}], "]"}], "]"}]}], ")"}]}]}], 
           "/", "2"}], ",", 
          RowBox[{"{", 
           RowBox[{"sp", ",", "m"}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"Print", "[", 
          RowBox[{"\"\<like1=\>\"", ",", "like1"}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"Print", "[", 
          RowBox[{"\"\<like2=\>\"", ",", "like2"}], "]"}], ";"}], 
        "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"ac", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"sp", ",", "m"}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"kk", "=", 
        RowBox[{"Table", "[", 
         RowBox[{"1.", ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "m"}], "}"}]}], "]"}]}], ";", " ", 
       "\[IndentingNewLine]", 
       RowBox[{"ta", "=", 
        RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"Do", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"update", "[", 
             RowBox[{"[", "1", "]"}], "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"(*", " ", 
             RowBox[{"update", " ", "be"}], " ", "*)"}], 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Do", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
                RowBox[{"nbe", "=", 
                 RowBox[{"be", "[", 
                  RowBox[{"[", "sp", "]"}], "]"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"nbe", "+=", 
                 RowBox[{"Random", "[", 
                  RowBox[{"MultinormalDistribution", "[", 
                   RowBox[{
                    RowBox[{"Table", "[", 
                    RowBox[{"0", ",", 
                    RowBox[{"{", 
                    RowBox[{"i", ",", "k"}], "}"}]}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"kk", "[", 
                    RowBox[{"[", "sp", "]"}], "]"}], "*", 
                    RowBox[{"V", "[", 
                    RowBox[{"[", 
                    RowBox[{"model", "[", 
                    RowBox[{"[", "sp", "]"}], "]"}], "]"}], "]"}]}]}], "]"}], 
                  "]"}]}], ";", "\[IndentingNewLine]", 
                RowBox[{"nlike1", "=", 
                 RowBox[{"loglike", "[", 
                  RowBox[{"X", ",", "sp", ",", "nbe", ",", "y"}], "]"}]}], 
                ";", "\[IndentingNewLine]", 
                RowBox[{"nlike2", "=", 
                 RowBox[{
                  RowBox[{"-", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{"nbe", "-", 
                    RowBox[{"mu", "[", 
                    RowBox[{"[", 
                    RowBox[{"model", "[", 
                    RowBox[{"[", "sp", "]"}], "]"}], "]"}], "]"}]}], ")"}], 
                    ".", 
                    RowBox[{"iV", "[", 
                    RowBox[{"[", 
                    RowBox[{"model", "[", 
                    RowBox[{"[", "sp", "]"}], "]"}], "]"}], "]"}], ".", 
                    RowBox[{"(", 
                    RowBox[{"nbe", "-", 
                    RowBox[{"mu", "[", 
                    RowBox[{"[", 
                    RowBox[{"model", "[", 
                    RowBox[{"[", "sp", "]"}], "]"}], "]"}], "]"}]}], 
                    ")"}]}]}], "/", "2"}]}], ";", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"ac", "[", 
                  RowBox[{"[", 
                   RowBox[{"sp", ",", "2"}], "]"}], "]"}], "+=", "1"}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"Random", "[", "]"}], "<", 
                   RowBox[{"Exp", "[", 
                    RowBox[{
                    RowBox[{"Total", "[", "nlike1", "]"}], "+", "nlike2", "-", 
                    RowBox[{"Total", "[", 
                    RowBox[{"like1", "[", 
                    RowBox[{"[", "sp", "]"}], "]"}], "]"}], "-", 
                    RowBox[{"like2", "[", 
                    RowBox[{"[", "sp", "]"}], "]"}]}], "]"}]}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"be", "[", 
                    RowBox[{"[", "sp", "]"}], "]"}], "=", "nbe"}], ";", 
                   "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"like1", "[", 
                    RowBox[{"[", "sp", "]"}], "]"}], "=", "nlike1"}], ";", 
                   "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"like2", "[", 
                    RowBox[{"[", "sp", "]"}], "]"}], "=", "nlike2"}], ";", 
                   "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"ac", "[", 
                    RowBox[{"[", 
                    RowBox[{"sp", ",", "1"}], "]"}], "]"}], "+=", "1"}], 
                   ";"}]}], "\[IndentingNewLine]", "]"}], ";"}], 
               "\[IndentingNewLine]", ",", 
               RowBox[{"{", 
                RowBox[{"sp", ",", "m"}], "}"}]}], "]"}], ";"}]}], 
           "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"update", "[", 
             RowBox[{"[", "2", "]"}], "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"(*", " ", 
             RowBox[{
              RowBox[{"UPDATE", " ", "V"}], ",", " ", "mu"}], " ", "*)"}], 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Do", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"mu0", ",", "Lambda0", ",", "kappa0", ",", "nu0"}], 
                  "}"}], "=", "primuV"}], ";", "\[IndentingNewLine]", 
                RowBox[{"ota", "=", 
                 RowBox[{"Flatten", "[", 
                  RowBox[{"Position", "[", 
                   RowBox[{"model", ",", "mixt"}], "]"}], "]"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"mbe", "=", 
                 RowBox[{"Mean", "[", 
                  RowBox[{"be", "[", 
                   RowBox[{"[", "ota", "]"}], "]"}], "]"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"S", "=", 
                 RowBox[{"Table", "[", 
                  RowBox[{"0", ",", 
                   RowBox[{"{", 
                    RowBox[{"i", ",", "k"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"j", ",", "k"}], "}"}]}], "]"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"Do", "[", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"v", "=", 
                    RowBox[{"{", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"be", "[", 
                    RowBox[{"[", 
                    RowBox[{"ota", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], "]"}], "-", 
                    "mbe"}], ")"}], "}"}]}], ";", "\[IndentingNewLine]", 
                   RowBox[{"S", "+=", 
                    RowBox[{
                    RowBox[{"Transpose", "[", "v", "]"}], ".", "v"}]}]}], 
                  "\[IndentingNewLine]", ",", 
                  RowBox[{"{", 
                   RowBox[{"i", ",", 
                    RowBox[{"Length", "[", "ota", "]"}]}], "}"}]}], "]"}], 
                ";", "\[IndentingNewLine]", 
                RowBox[{"num", "=", 
                 RowBox[{"nu0", "+", 
                  RowBox[{"Length", "[", "ota", "]"}]}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"Lambdam", "=", 
                 RowBox[{"Lambda0", "+", "S", "+", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"kappa0", " ", 
                    RowBox[{"Length", "[", "ota", "]"}]}], ")"}], "/", 
                    RowBox[{"(", 
                    RowBox[{"kappa0", "+", 
                    RowBox[{"Length", "[", "ota", "]"}]}], ")"}]}], ")"}], 
                   " ", 
                   RowBox[{
                    RowBox[{"Transpose", "[", 
                    RowBox[{"{", 
                    RowBox[{"mbe", "-", "mu0"}], "}"}], "]"}], ".", 
                    RowBox[{"{", 
                    RowBox[{"mbe", "-", "mu0"}], "}"}]}]}]}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"iLambdam", "=", 
                 RowBox[{"Inverse", "[", "Lambdam", "]"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"iLambdam", "=", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"iLambdam", "+", 
                    RowBox[{"Transpose", "[", "iLambdam", "]"}]}], ")"}], "/",
                   "2"}]}], ";", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"V", "[", 
                  RowBox[{"[", "mixt", "]"}], "]"}], "=", 
                 RowBox[{"Inverse", "[", 
                  RowBox[{"RandomReal", "[", 
                   RowBox[{"WishartDistribution", "[", 
                    RowBox[{"iLambdam", ",", "num"}], "]"}], "]"}], "]"}]}], 
                ";", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"V", "[", 
                  RowBox[{"[", "mixt", "]"}], "]"}], "=", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"V", "[", 
                    RowBox[{"[", "mixt", "]"}], "]"}], "+", 
                    RowBox[{"Transpose", "[", 
                    RowBox[{"V", "[", 
                    RowBox[{"[", "mixt", "]"}], "]"}], "]"}]}], ")"}], "/", 
                  "2"}]}], ";", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"iV", "[", 
                  RowBox[{"[", "mixt", "]"}], "]"}], "=", 
                 RowBox[{"Inverse", "[", 
                  RowBox[{"V", "[", 
                   RowBox[{"[", "mixt", "]"}], "]"}], "]"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"mum", "=", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"kappa0", "/", 
                    RowBox[{"(", 
                    RowBox[{"kappa0", "+", 
                    RowBox[{"Length", "[", "ota", "]"}]}], ")"}]}], ")"}], 
                   " ", "mu0"}], "+", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"Length", "[", "ota", "]"}], "/", 
                    RowBox[{"(", 
                    RowBox[{"kappa0", "+", 
                    RowBox[{"Length", "[", "ota", "]"}]}], ")"}]}], ")"}], 
                   " ", "mbe"}]}]}], ";", "\[IndentingNewLine]", 
                RowBox[{"kappam", "=", 
                 RowBox[{"kappa0", "+", 
                  RowBox[{"Length", "[", "ota", "]"}]}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"Vk", "=", 
                 RowBox[{
                  RowBox[{"V", "[", 
                   RowBox[{"[", "mixt", "]"}], "]"}], "/", "kappam"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"Vk", "=", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"Vk", "+", 
                    RowBox[{"Transpose", "[", "Vk", "]"}]}], ")"}], "/", 
                  "2"}]}], ";", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"mu", "[", 
                  RowBox[{"[", "mixt", "]"}], "]"}], "=", 
                 RowBox[{"RandomReal", "[", 
                  RowBox[{"MultinormalDistribution", "[", 
                   RowBox[{"mum", ",", "Vk"}], "]"}], "]"}]}], ";"}], 
               "\[IndentingNewLine]", ",", 
               RowBox[{"{", 
                RowBox[{"mixt", ",", "nmixt"}], "}"}]}], "]"}], ";"}]}], 
           "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"like2", "=", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"be", "[", 
                   RowBox[{"[", "sp", "]"}], "]"}], "-", 
                  RowBox[{"mu", "[", 
                   RowBox[{"[", 
                    RowBox[{"model", "[", 
                    RowBox[{"[", "sp", "]"}], "]"}], "]"}], "]"}]}], ")"}], 
                ".", 
                RowBox[{"iV", "[", 
                 RowBox[{"[", 
                  RowBox[{"model", "[", 
                   RowBox[{"[", "sp", "]"}], "]"}], "]"}], "]"}], ".", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"be", "[", 
                   RowBox[{"[", "sp", "]"}], "]"}], "-", 
                  RowBox[{"mu", "[", 
                   RowBox[{"[", 
                    RowBox[{"model", "[", 
                    RowBox[{"[", "sp", "]"}], "]"}], "]"}], "]"}]}], 
                 ")"}]}]}], "/", "2"}], ",", 
             RowBox[{"{", 
              RowBox[{"sp", ",", "m"}], "}"}]}], "]"}]}], ";", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"(*", " ", 
           RowBox[{"update", " ", "f"}], " ", "*)"}], "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"update", "[", 
              RowBox[{"[", "3", "]"}], "]"}], " ", "&&", " ", 
             RowBox[{"nmixt", "\[Equal]", "2"}]}], ",", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"f", "=", 
              RowBox[{"RandomReal", "[", 
               RowBox[{"BetaDistribution", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Count", "[", 
                   RowBox[{"model", ",", "1"}], "]"}], "+", "1"}], ",", 
                 RowBox[{
                  RowBox[{"Count", "[", 
                   RowBox[{"model", ",", "2"}], "]"}], "+", "1"}]}], "]"}], 
               "]"}]}], ";"}]}], "\[IndentingNewLine]", "]"}], ";", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"(*", " ", 
           RowBox[{"update", " ", "model"}], " ", "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"update", "[", 
              RowBox[{"[", "4", "]"}], "]"}], " ", "&&", " ", 
             RowBox[{"nmixt", "\[Equal]", "2"}]}], ",", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"li1", "=", 
              RowBox[{"f", "*", 
               RowBox[{
                RowBox[{"Exp", "[", 
                 RowBox[{"Table", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"be", "[", 
                    RowBox[{"[", "sp", "]"}], "]"}], "-", 
                    RowBox[{"mu", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], ")"}], ".", 
                    RowBox[{"iV", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ".", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"be", "[", 
                    RowBox[{"[", "sp", "]"}], "]"}], "-", 
                    RowBox[{"mu", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], ")"}]}]}], "/", "2"}], 
                   ",", 
                   RowBox[{"{", 
                    RowBox[{"sp", ",", "m"}], "}"}]}], "]"}], "]"}], "/", 
                RowBox[{"Sqrt", "[", 
                 RowBox[{"Det", "[", 
                  RowBox[{"V", "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "]"}], "]"}]}]}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"li2", "=", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"1", "-", "f"}], ")"}], "*", 
               RowBox[{
                RowBox[{"Exp", "[", 
                 RowBox[{"Table", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"be", "[", 
                    RowBox[{"[", "sp", "]"}], "]"}], "-", 
                    RowBox[{"mu", "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}], ")"}], ".", 
                    RowBox[{"iV", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ".", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"be", "[", 
                    RowBox[{"[", "sp", "]"}], "]"}], "-", 
                    RowBox[{"mu", "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}], ")"}]}]}], "/", "2"}], 
                   ",", 
                   RowBox[{"{", 
                    RowBox[{"sp", ",", "m"}], "}"}]}], "]"}], "]"}], "/", 
                RowBox[{"Sqrt", "[", 
                 RowBox[{"Det", "[", 
                  RowBox[{"V", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "]"}], "]"}]}]}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"model", "=", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"Random", "[", "]"}], "<", 
                   RowBox[{
                    RowBox[{"li1", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "/", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"li1", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "+", 
                    RowBox[{"li2", "[", 
                    RowBox[{"[", "i", "]"}], "]"}]}], ")"}]}]}], ",", "1", 
                  ",", "2"}], "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"i", ",", "m"}], "}"}]}], "]"}]}]}]}], 
           "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"Quiet", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"r", "=", 
             RowBox[{"N", "[", 
              RowBox[{
               RowBox[{"ac", "[", 
                RowBox[{"[", 
                 RowBox[{"All", ",", "1"}], "]"}], "]"}], "/", 
               RowBox[{"ac", "[", 
                RowBox[{"[", 
                 RowBox[{"All", ",", "2"}], "]"}], "]"}]}], "]"}]}], ";"}], 
           "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"zz", "<", "trans"}], ",", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"w", "=", 
              RowBox[{"1", "-", 
               RowBox[{"0.5", " ", 
                RowBox[{"N", "[", 
                 RowBox[{"Exp", "[", 
                  RowBox[{
                   RowBox[{"-", "zz"}], "/", "relax"}], "]"}], "]"}]}]}]}], 
             ";", "\[IndentingNewLine]", 
             RowBox[{"aa", "=", 
              RowBox[{"N", "[", 
               RowBox[{"Exp", "[", 
                RowBox[{
                 RowBox[{"-", "zz"}], "/", "relax"}], "]"}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"kk", "*=", 
              RowBox[{"Exp", "[", 
               RowBox[{"aa", 
                RowBox[{"(", 
                 RowBox[{"r", "-", "0.44"}], ")"}]}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"ac", "*=", "w"}], ";"}]}], "\[IndentingNewLine]", "]"}],
           ";", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"zz", "\[Equal]", "trans"}], ",", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"ta", "=", 
              RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"ac", "=", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"sp", ",", "m"}], "}"}]}], "]"}]}], ";"}]}], 
           "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Mod", "[", 
              RowBox[{"zz", ",", "thin"}], "]"}], "\[Equal]", "0"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"AppendTo", "[", 
              RowBox[{"ta", ",", 
               RowBox[{"{", 
                RowBox[{"mu", ",", "V", ",", "be", ",", "f", ",", "model"}], 
                "}"}]}], "]"}], ";"}]}], "\[IndentingNewLine]", "]"}], ";"}], 
         "\[IndentingNewLine]", ",", 
         RowBox[{"{", 
          RowBox[{"zz", ",", 
           RowBox[{"trans", "+", "iter"}]}], "}"}]}], "]"}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{"ar", ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Print", "[", 
           RowBox[{"\"\<accept ratios for be: \>\"", ",", 
            RowBox[{"Sort", "[", 
             RowBox[{"N", "[", "r", "]"}], "]"}]}], "]"}], ";"}]}], 
        "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", "ta"}]}], 
     "\[IndentingNewLine]", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MCMCpars", "[", "p_", "]"}], ":=", 
   RowBox[{"MCMC", "[", 
    RowBox[{
     RowBox[{"p", "[", 
      RowBox[{"[", "1", "]"}], "]"}], ",", 
     RowBox[{"p", "[", 
      RowBox[{"[", "2", "]"}], "]"}], ",", 
     RowBox[{"p", "[", 
      RowBox[{"[", "3", "]"}], "]"}], ",", 
     RowBox[{"p", "[", 
      RowBox[{"[", "4", "]"}], "]"}], ",", 
     RowBox[{"p", "[", 
      RowBox[{"[", "5", "]"}], "]"}], ",", 
     RowBox[{"p", "[", 
      RowBox[{"[", "6", "]"}], "]"}], ",", 
     RowBox[{"p", "[", 
      RowBox[{"[", "7", "]"}], "]"}], ",", 
     RowBox[{"p", "[", 
      RowBox[{"[", "8", "]"}], "]"}], ",", 
     RowBox[{"p", "[", 
      RowBox[{"[", "9", "]"}], "]"}], ",", 
     RowBox[{"p", "[", 
      RowBox[{"[", "10", "]"}], "]"}], ",", 
     RowBox[{"p", "[", 
      RowBox[{"[", "11", "]"}], "]"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{
  3.4638199218492002`*^9, {3.4638226029309998`*^9, 3.4638226030246*^9}, {
   3.4638278017782*^9, 3.463827806271*^9}, {3.4638279990713997`*^9, 
   3.463827999321*^9}, {3.4638290178761997`*^9, 3.4638290179698*^9}, {
   3.4638294399744*^9, 3.4638294537492*^9}, {3.4638294859164*^9, 
   3.46382963967*^9}, {3.4638535653836*^9, 3.4638535832455997`*^9}, {
   3.4638536777816*^9, 3.4638537135212*^9}, {3.4638537475916*^9, 
   3.4638538502864*^9}, {3.4638542100243998`*^9, 3.4638542841912003`*^9}, {
   3.4638545917648*^9, 3.4638545946664*^9}, {3.4638546641488*^9, 
   3.4638546645388002`*^9}, {3.463855922961*^9, 3.4638559587785997`*^9}, {
   3.4638560072478*^9, 3.463856018667*^9}, {3.4638560802558002`*^9, 
   3.4638560856534*^9}, {3.4638573536802*^9, 3.4638573660666*^9}, {
   3.4638579337826*^9, 3.4638579339230003`*^9}, {3.4639058588622*^9, 
   3.4639058759598*^9}, {3.4639124063702*^9, 3.4639124335298*^9}, {
   3.4639124998328*^9, 3.4639125021415997`*^9}, {3.4639126064276*^9, 
   3.4639126091264*^9}, {3.4639129552406*^9, 3.4639129586414003`*^9}, {
   3.4639141597558002`*^9, 3.4639141716118*^9}, {3.4639143558789997`*^9, 
   3.4639143751918*^9}, {3.4639165166266003`*^9, 3.4639165168294*^9}, {
   3.4639454292754*^9, 3.4639454294002*^9}, {3.4639454873386*^9, 
   3.4639455034066*^9}, {3.463981268949794*^9, 3.463981359320594*^9}, {
   3.4639814850253935`*^9, 3.4639815151177936`*^9}, {3.4779106847026*^9, 
   3.4779107405506*^9}, {3.4779107834194*^9, 3.4779108211401997`*^9}, {
   3.4779108524337997`*^9, 3.4779109210114*^9}, {3.4779172087802*^9, 
   3.4779172090142*^9}, {3.4779192995553923`*^9, 3.477919343422592*^9}, 
   3.4779201315048*^9, {3.4779201851219997`*^9, 3.4779201886632*^9}, {
   3.4779221995888*^9, 3.4779224296576*^9}, {3.4779224686731997`*^9, 
   3.4779226408816*^9}, 3.4779227553392*^9, {3.4779228949556*^9, 
   3.4779228960008*^9}, {3.4779232810982*^9, 3.4779233015654*^9}, {
   3.4779244984286003`*^9, 3.477924514013*^9}, {3.4779245995268*^9, 
   3.4779246634088*^9}, {3.4779695075402*^9, 3.4779696342902*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"MODEL", "=", "1"}], ";"}], " ", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"1", " ", "=", " ", 
     RowBox[{"no", " ", "mixture"}]}], ",", " ", 
    RowBox[{"2", " ", "=", " ", "mixture"}]}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"MODEL", "\[Equal]", "1"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"n", "=", "100"}], ";", " ", 
      RowBox[{"(*", " ", 
       RowBox[{"n", ".", "o", ".", " ", "sites"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"m", "=", "100"}], ";", " ", 
      RowBox[{"(*", " ", 
       RowBox[{"n", ".", "o", ".", " ", "species"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"m1", "=", "5"}], ";", " ", 
      RowBox[{"(*", " ", 
       RowBox[{"subset", " ", "of", " ", "species"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"k", "=", "2"}], ";", "\[IndentingNewLine]", 
      RowBox[{"mu", "=", 
       RowBox[{"mur", "=", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "3"}], ",", "1"}], "}"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"rho", "=", "0.8"}], ";", "\[IndentingNewLine]", 
      RowBox[{"si1", "=", "2"}], ";", "\[IndentingNewLine]", 
      RowBox[{"si2", "=", "1"}], ";", "\[IndentingNewLine]", 
      RowBox[{"V", "=", 
       RowBox[{"Vr", "=", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"si1", "^", "2"}], ",", 
            RowBox[{
             RowBox[{"-", "rho"}], " ", "si1", " ", "si2"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "rho"}], " ", "si1", " ", "si2"}], ",", 
            RowBox[{"si2", "^", "2"}]}], "}"}]}], "}"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"be", "=", 
       RowBox[{"ber", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"RandomReal", "[", 
           RowBox[{"MultinormalDistribution", "[", 
            RowBox[{"mu", ",", "V"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "m"}], "}"}]}], "]"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"X", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", 
           RowBox[{"RandomReal", "[", 
            RowBox[{"NormalDistribution", "[", 
             RowBox[{"0", ",", "1"}], "]"}], "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "n"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"p", "=", 
       RowBox[{"ilogit", "[", 
        RowBox[{"X", ".", 
         RowBox[{"Transpose", "[", "be", "]"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"padata", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"RandomReal", "[", "]"}], "<", 
            RowBox[{"p", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "j"}], "]"}], "]"}]}], ",", "1", ",", "0"}], 
          "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "n"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"j", ",", "m"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{"ListPlot", "[", "be", "]"}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{"False", ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"me", "=", 
          RowBox[{"Mean", "[", 
           RowBox[{"X", "[", 
            RowBox[{"[", 
             RowBox[{"All", ",", "2"}], "]"}], "]"}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"Do", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"X", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "2"}], "]"}], "]"}], "-=", "me"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "n"}], "}"}]}], "]"}], ";"}]}], 
       "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Histogram", "[", 
          RowBox[{"Total", "[", "padata", "]"}], "]"}], ",", 
         RowBox[{"Histogram", "[", 
          RowBox[{"Map", "[", 
           RowBox[{"Total", ",", "padata"}], "]"}], "]"}]}], "}"}], "]"}], 
      ";", "\[IndentingNewLine]", 
      RowBox[{"ytot", "=", 
       RowBox[{"Total", "[", "padata", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"order", "=", 
       RowBox[{
        RowBox[{"Sort", "[", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"ytot", ",", 
            RowBox[{"Table", "[", 
             RowBox[{"i", ",", 
              RowBox[{"{", 
               RowBox[{"i", ",", "m"}], "}"}]}], "]"}]}], "}"}], "]"}], "]"}],
         "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "2"}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"dif", "=", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"ytot", "[", 
           RowBox[{"[", "order", "]"}], "]"}], "-", 
          RowBox[{"n", "/", "2"}]}], ")"}], "^", "2"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"mid", "=", 
       RowBox[{
        RowBox[{"Position", "[", 
         RowBox[{"dif", ",", 
          RowBox[{"Min", "[", "dif", "]"}]}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{"1", ",", "1"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"list", "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"order", "[", 
          RowBox[{"[", "1", "]"}], "]"}], ",", 
         RowBox[{"order", "[", 
          RowBox[{"[", "mid", "]"}], "]"}]}], "}"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"list2", "=", 
       RowBox[{"Join", "[", 
        RowBox[{"list", ",", 
         RowBox[{"Take", "[", 
          RowBox[{
           RowBox[{"Complement", "[", 
            RowBox[{
             RowBox[{"Table", "[", 
              RowBox[{"i", ",", 
               RowBox[{"{", 
                RowBox[{"i", ",", "m"}], "}"}]}], "]"}], ",", "list"}], "]"}],
            ",", 
           RowBox[{"m1", "-", 
            RowBox[{"Length", "[", "list", "]"}]}]}], "]"}]}], "]"}]}], 
      ";"}]}], "\[IndentingNewLine]", "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"MODEL", "\[Equal]", "2"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"n", "=", "100"}], ";", " ", 
     RowBox[{"(*", " ", 
      RowBox[{"n", ".", "o", ".", " ", "sites"}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"m", "=", "100"}], ";", " ", 
     RowBox[{"(*", " ", 
      RowBox[{"n", ".", "o", ".", " ", "species"}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"m1", "=", "5"}], ";", " ", 
     RowBox[{"(*", " ", 
      RowBox[{"subset", " ", "of", " ", "species"}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"k", "=", "2"}], ";", "\[IndentingNewLine]", 
     RowBox[{"mu1", "=", 
      RowBox[{"mur1", "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "4"}], ",", 
         RowBox[{"-", "2"}]}], "}"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"mu2", "=", 
      RowBox[{"mur2", "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "4"}], ",", "2"}], "}"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"rho1", "=", "0.8"}], ";", "\[IndentingNewLine]", 
     RowBox[{"rho2", "=", 
      RowBox[{"-", "0.8"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"si11", "=", "2"}], ";", "\[IndentingNewLine]", 
     RowBox[{"si12", "=", "1"}], ";", "\[IndentingNewLine]", 
     RowBox[{"si21", "=", "2"}], ";", "\[IndentingNewLine]", 
     RowBox[{"si22", "=", "2"}], ";", "\[IndentingNewLine]", 
     RowBox[{"V1", "=", 
      RowBox[{"Vr1", "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"si11", "^", "2"}], ",", " ", 
           RowBox[{"rho1", " ", "si11", " ", "si12"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"rho1", " ", "si11", " ", "si12"}], ",", 
           RowBox[{"si12", "^", "2"}]}], "}"}]}], "}"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"V2", "=", 
      RowBox[{"Vr2", "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"si21", "^", "2"}], ",", " ", 
           RowBox[{"rho2", " ", "si21", " ", "si22"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"rho2", " ", "si21", " ", "si22"}], ",", 
           RowBox[{"si22", "^", "2"}]}], "}"}]}], "}"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"f", "=", 
      RowBox[{"fr", "=", "0.3"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"model", "=", 
      RowBox[{"modelr", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Random", "[", "]"}], "<", "fr"}], ",", "1", ",", "2"}], 
          "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "m"}], "}"}]}], "]"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"be", "=", 
      RowBox[{"ber", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"RandomReal", "[", 
          RowBox[{"MultinormalDistribution", "[", 
           RowBox[{
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"model", "[", 
                RowBox[{"[", "i", "]"}], "]"}], "\[Equal]", "1"}], ",", "mu1",
               ",", "mu2"}], "]"}], ",", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"model", "[", 
                RowBox[{"[", "i", "]"}], "]"}], "\[Equal]", "1"}], ",", "V1", 
              ",", "V2"}], "]"}]}], "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "m"}], "}"}]}], "]"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"X", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", 
          RowBox[{"RandomReal", "[", 
           RowBox[{"NormalDistribution", "[", 
            RowBox[{"0", ",", "1"}], "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "n"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"p", "=", 
      RowBox[{"ilogit", "[", 
       RowBox[{"X", ".", 
        RowBox[{"Transpose", "[", "be", "]"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"padata", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"RandomReal", "[", "]"}], "<", 
           RowBox[{"p", "[", 
            RowBox[{"[", 
             RowBox[{"i", ",", "j"}], "]"}], "]"}]}], ",", "1", ",", "0"}], 
         "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "n"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"j", ",", "m"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Print", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Histogram", "[", 
         RowBox[{"Total", "[", "padata", "]"}], "]"}], ",", 
        RowBox[{"Histogram", "[", 
         RowBox[{"Map", "[", 
          RowBox[{"Total", ",", "padata"}], "]"}], "]"}]}], "}"}], "]"}], ";",
      "\[IndentingNewLine]", 
     RowBox[{"ytot", "=", 
      RowBox[{"Total", "[", "padata", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"order", "=", 
      RowBox[{
       RowBox[{"Sort", "[", 
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"ytot", ",", 
           RowBox[{"Table", "[", 
            RowBox[{"i", ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "m"}], "}"}]}], "]"}]}], "}"}], "]"}], "]"}], 
       "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "2"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Print", "[", 
      RowBox[{"Sort", "[", "ytot", "]"}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"dif", "=", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"ytot", "[", 
          RowBox[{"[", "order", "]"}], "]"}], "-", 
         RowBox[{"n", "/", "2"}]}], ")"}], "^", "2"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"mid", "=", 
      RowBox[{
       RowBox[{"Position", "[", 
        RowBox[{"dif", ",", 
         RowBox[{"Min", "[", "dif", "]"}]}], "]"}], "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "1"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"list", "=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"order", "[", 
         RowBox[{"[", "1", "]"}], "]"}], ",", 
        RowBox[{"order", "[", 
         RowBox[{"[", "mid", "]"}], "]"}]}], "}"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"list2", "=", 
      RowBox[{"Join", "[", 
       RowBox[{"list", ",", 
        RowBox[{"Take", "[", 
         RowBox[{
          RowBox[{"Complement", "[", 
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{"i", ",", 
              RowBox[{"{", 
               RowBox[{"i", ",", "m"}], "}"}]}], "]"}], ",", "list"}], "]"}], 
          ",", 
          RowBox[{"m1", "-", 
           RowBox[{"Length", "[", "list", "]"}]}]}], "]"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"list0", "=", 
      RowBox[{"Flatten", "[", 
       RowBox[{"Position", "[", 
        RowBox[{"ytot", ",", "0"}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"f0", "=", 
      RowBox[{"ListPlot", "[", 
       RowBox[{
        RowBox[{"be", "[", 
         RowBox[{"[", "list0", "]"}], "]"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"GrayLevel", "[", "0.7", "]"}], ",", 
           RowBox[{"PointSize", "[", "Large", "]"}]}], "}"}]}]}], "]"}]}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"f1", "=", 
      RowBox[{"ListPlot", "[", "be", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"f2", "=", 
      RowBox[{"ListPlot", "[", 
       RowBox[{
        RowBox[{"be", "[", 
         RowBox[{"[", "list", "]"}], "]"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Red", ",", 
           RowBox[{"PointSize", "[", "Medium", "]"}]}], "}"}]}]}], "]"}]}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"f3", "=", 
      RowBox[{"ListPlot", "[", 
       RowBox[{
        RowBox[{"be", "[", 
         RowBox[{"[", "list2", "]"}], "]"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Black", ",", 
           RowBox[{"PointSize", "[", "Medium", "]"}]}], "}"}]}]}], "]"}]}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"Print", "[", 
      RowBox[{"Show", "[", 
       RowBox[{"f0", ",", "f1", ",", "f3", ",", "f2"}], "]"}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Print", "[", 
      RowBox[{"ytot", "[", 
       RowBox[{"[", "list", "]"}], "]"}], "]"}], ";"}]}], 
   "\[IndentingNewLine]", "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.463819844208*^9, 3.4638198965615997`*^9}, {
   3.4638199568244*^9, 3.4638200913900003`*^9}, {3.4638201244776*^9, 
   3.463820143884*^9}, {3.4638202660788*^9, 3.4638204622019997`*^9}, {
   3.4638208235448*^9, 3.4638208522799997`*^9}, {3.4638209347416*^9, 
   3.4638209538984003`*^9}, {3.463821083238*^9, 3.4638210886512003`*^9}, {
   3.4638211280582*^9, 3.4638211296026*^9}, {3.4638219486338*^9, 
   3.4638219498506002`*^9}, {3.4638226158322*^9, 3.4638226299189997`*^9}, {
   3.463823404929*^9, 3.4638234055842*^9}, {3.4638235152209997`*^9, 
   3.463823515299*^9}, {3.4638278601222*^9, 3.4638278610114*^9}, {
   3.463828082703*^9, 3.4638281275998*^9}, {3.4638290248182*^9, 
   3.4638290270646*^9}, {3.4638297184968*^9, 3.4638297186528*^9}, {
   3.463830033648*^9, 3.46383003591*^9}, {3.463830500868*^9, 
   3.4638305021316*^9}, {3.4638533813816*^9, 3.4638533987132*^9}, {
   3.4638549530764*^9, 3.46385495356*^9}, {3.4638558047130003`*^9, 
   3.4638558048222*^9}, {3.4638564499164*^9, 3.463856450166*^9}, {
   3.4638567026404*^9, 3.4638567117664003`*^9}, {3.4638570518152*^9, 
   3.46385705194*^9}, 3.4638571934007998`*^9, {3.4638579436261997`*^9, 
   3.4638579454358*^9}, {3.4638581110922003`*^9, 3.4638581114666*^9}, {
   3.4639057687722*^9, 3.4639057693806*^9}, {3.4639059256076*^9, 
   3.4639059256856003`*^9}, {3.4639130089358*^9, 3.4639130350657997`*^9}, 
   3.4639148165002003`*^9, {3.4639149493342*^9, 3.4639149544666*^9}, {
   3.463915756916*^9, 3.463915757072*^9}, {3.46391599583*^9, 
   3.4639159958768*^9}, {3.4639161133448*^9, 3.4639161134228*^9}, {
   3.4639174040884*^9, 3.4639174146496*^9}, {3.4639253012292*^9, 
   3.4639253626152*^9}, {3.4639439642892*^9, 3.4639439649756002`*^9}, {
   3.477920157042*^9, 3.4779201572916*^9}, {3.47792028465*^9, 
   3.4779202851804*^9}, {3.4779212650786*^9, 3.4779213246882*^9}, {
   3.4779219369442*^9, 3.4779219925582*^9}, {3.4779226529248*^9, 
   3.4779226530028*^9}, {3.4779228127244*^9, 3.4779228127868*^9}, {
   3.4779700505816*^9, 3.4779700506284*^9}, {3.4779720311734*^9, 
   3.4779720317349997`*^9}, {3.492780847428035*^9, 3.492780847459235*^9}, {
   3.4937078786676292`*^9, 3.49370788785597*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"PRI", "=", "2"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"PRI", "\[Equal]", "1"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"mu0", "=", 
      RowBox[{"Table", "[", 
       RowBox[{"0", ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "k"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Lambda0", "=", 
      RowBox[{"IdentityMatrix", "[", "k", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"kappa0", "=", "0"}], ";", "\[IndentingNewLine]", 
     RowBox[{"nu0", "=", "k"}], ";", "\[IndentingNewLine]", 
     RowBox[{"primuV", "=", 
      RowBox[{"{", 
       RowBox[{"mu0", ",", "Lambda0", ",", "kappa0", ",", "nu0"}], "}"}]}], 
     ";"}]}], "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"PRI", "\[Equal]", "2"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"mu0", "=", 
       RowBox[{"Table", "[", 
        RowBox[{"0", ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "k"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Lambda0", "=", 
       RowBox[{"IdentityMatrix", "[", "k", "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"kappa0", "=", "5"}], ";", "\[IndentingNewLine]", 
      RowBox[{"nu0", "=", 
       RowBox[{"k", "+", "5"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"primuV", "=", 
       RowBox[{"{", 
        RowBox[{"mu0", ",", "Lambda0", ",", "kappa0", ",", "nu0"}], "}"}]}], 
      ";"}]}], "\[IndentingNewLine]", "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"relax", "=", "500"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"trans", "=", "10"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"iter", "=", "40"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"thin", "=", 
   RowBox[{"Max", "[", 
    RowBox[{
     RowBox[{"Round", "[", 
      RowBox[{"iter", "/", "100"}], "]"}], ",", "1"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"parsF", "=", 
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{
     "trans", ",", "iter", ",", "X", ",", "padata", ",", "primuV", ",", 
      "thin", ",", "relax", ",", 
      RowBox[{"{", 
       RowBox[{"True", ",", "True", ",", "True", ",", "True"}], "}"}], ",", 
      "True", ",", "ber", ",", "MODEL"}], "}"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pars5", "=", 
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{"trans", ",", "iter", ",", "X", ",", 
      RowBox[{"padata", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "list2"}], "]"}], "]"}], ",", "primuV", ",", 
      "thin", ",", "relax", ",", 
      RowBox[{"{", 
       RowBox[{"True", ",", "True", ",", "True", ",", "True"}], "}"}], ",", 
      "True", ",", 
      RowBox[{"ber", "[", 
       RowBox[{"[", "list2", "]"}], "]"}], ",", "MODEL"}], "}"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"parsI", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"trans", ",", "iter", ",", "X", ",", 
       RowBox[{"padata", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", 
          RowBox[{"{", 
           RowBox[{"list", "[", 
            RowBox[{"[", "i", "]"}], "]"}], "}"}]}], "]"}], "]"}], ",", 
       "primuV", ",", "thin", ",", "relax", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "True", ",", "True", ",", "True"}], "}"}], ",", 
       "True", ",", 
       RowBox[{"ber", "[", 
        RowBox[{"[", 
         RowBox[{"{", 
          RowBox[{"list", "[", 
           RowBox[{"[", "i", "]"}], "]"}], "}"}], "]"}], "]"}], ",", 
       "MODEL"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", 
       RowBox[{"Length", "[", "list", "]"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pars", "=", 
   RowBox[{"Join", "[", 
    RowBox[{"parsF", ",", "pars5", ",", "parsI"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.4639813843741937`*^9, 3.4639813874005938`*^9}, {
   3.4639814409085937`*^9, 3.4639814434825935`*^9}, {3.4779193575717926`*^9, 
   3.4779193609413924`*^9}, {3.4779201456851997`*^9, 3.477920145966*^9}, {
   3.4779204284820004`*^9, 3.4779204916152*^9}, {3.4779208831408*^9, 
   3.4779209264463997`*^9}, {3.4779210753348*^9, 3.4779210800928*^9}, 
   3.4779213019434*^9, {3.4779221693248*^9, 3.4779221816800003`*^9}, {
   3.477922661146*^9, 3.4779226617232*^9}, {3.4779234347738*^9, 
   3.4779234480806*^9}, {3.4779697658348*^9, 3.4779697718876*^9}, {
   3.4779700677104*^9, 3.4779700957904*^9}, {3.4779720110806*^9, 
   3.4779720148714*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Quiet", "[", 
  RowBox[{"AbsoluteTiming", "[", 
   RowBox[{
    RowBox[{"tass", "=", 
     RowBox[{"Map", "[", 
      RowBox[{"MCMCpars", ",", "pars"}], "]"}]}], ";"}], "]"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.4779171636182003`*^9, 3.4779171680642*^9}, {
   3.4779203840220003`*^9, 3.4779203854572*^9}, 3.4779204752352*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"accept ratios for be: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "0.025`", ",", "0.075`", ",", "0.075`", ",", "0.1`", ",", "0.125`", ",", 
     "0.125`", ",", "0.125`", ",", "0.15`", ",", "0.15`", ",", "0.175`", ",", 
     "0.175`", ",", "0.175`", ",", "0.175`", ",", "0.2`", ",", "0.2`", ",", 
     "0.2`", ",", "0.2`", ",", "0.225`", ",", "0.225`", ",", "0.225`", ",", 
     "0.25`", ",", "0.25`", ",", "0.25`", ",", "0.25`", ",", "0.275`", ",", 
     "0.275`", ",", "0.275`", ",", "0.275`", ",", "0.3`", ",", "0.3`", ",", 
     "0.3`", ",", "0.3`", ",", "0.3`", ",", "0.325`", ",", "0.325`", ",", 
     "0.325`", ",", "0.325`", ",", "0.325`", ",", "0.325`", ",", "0.325`", 
     ",", "0.35`", ",", "0.35`", ",", "0.35`", ",", "0.375`", ",", "0.375`", 
     ",", "0.375`", ",", "0.375`", ",", "0.375`", ",", "0.375`", ",", 
     "0.375`", ",", "0.375`", ",", "0.375`", ",", "0.375`", ",", "0.375`", 
     ",", "0.375`", ",", "0.4`", ",", "0.4`", ",", "0.4`", ",", "0.4`", ",", 
     "0.4`", ",", "0.4`", ",", "0.4`", ",", "0.4`", ",", "0.425`", ",", 
     "0.425`", ",", "0.425`", ",", "0.425`", ",", "0.425`", ",", "0.425`", 
     ",", "0.45`", ",", "0.45`", ",", "0.45`", ",", "0.45`", ",", "0.475`", 
     ",", "0.475`", ",", "0.475`", ",", "0.475`", ",", "0.475`", ",", 
     "0.475`", ",", "0.475`", ",", "0.475`", ",", "0.475`", ",", "0.475`", 
     ",", "0.475`", ",", "0.5`", ",", "0.5`", ",", "0.525`", ",", "0.525`", 
     ",", "0.55`", ",", "0.55`", ",", "0.55`", ",", "0.575`", ",", "0.575`", 
     ",", "0.6`", ",", "0.6`", ",", "0.625`", ",", "0.65`", ",", "0.75`", ",",
      "0.775`", ",", "0.8`"}], "}"}]}],
  SequenceForm["accept ratios for be: ", CompressedData["
1:eJxTTMoPSmVkYGBIAeJZM8HA3hgMNsNpiPhOewYwOIBBQ9QdhtNpYHAMJw0x
7yRO+uwZMMCgIfZdwElD9F/ESUPcd5kgDbHvCsk0xH/XMGiI+27QjIb47ybZ
NMTft4mmIf69g5OG+Pse1WmIfx/AaYh9CBrin4cYNET/IzgN8cdjOA0x7wnU
nCdQ/gso/wXUnJf2AEX7Vzk=
   "]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.4779193761981926`*^9, 3.4779194938689923`*^9, {3.4779201762455997`*^9, 
   3.477920228646*^9}, 3.4779202822320004`*^9, 3.477920387454*^9, {
   3.4779204708828*^9, 3.4779204787764*^9}, 3.4779205272768*^9, 
   3.477920922796*^9, 3.4779209617648*^9, 3.4779211165811996`*^9, 
   3.4779215756368*^9, 3.4779216784116*^9, 3.4779221453943996`*^9, 
   3.4779226684*^9, 3.4779227629988003`*^9, 3.4779228191516*^9, 
   3.47792290352*^9, 3.4779230308798*^9, 3.4779234532754*^9, 
   3.4779692812276*^9, 3.477969644633*^9, 3.477969863756*^9, 
   3.4779700773824*^9, 3.4779701805296*^9, {3.4779720200506*^9, 
   3.477972037585*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"accept ratios for be: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"0.35`", ",", "0.4`", ",", "0.55`", ",", "0.6`", ",", "0.775`"}], 
    "}"}]}],
  SequenceForm["accept ratios for be: ", {0.35, 0.4, 0.55, 0.6, 0.775}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.4779193761981926`*^9, 3.4779194938689923`*^9, {3.4779201762455997`*^9, 
   3.477920228646*^9}, 3.4779202822320004`*^9, 3.477920387454*^9, {
   3.4779204708828*^9, 3.4779204787764*^9}, 3.4779205272768*^9, 
   3.477920922796*^9, 3.4779209617648*^9, 3.4779211165811996`*^9, 
   3.4779215756368*^9, 3.4779216784116*^9, 3.4779221453943996`*^9, 
   3.4779226684*^9, 3.4779227629988003`*^9, 3.4779228191516*^9, 
   3.47792290352*^9, 3.4779230308798*^9, 3.4779234532754*^9, 
   3.4779692812276*^9, 3.477969644633*^9, 3.477969863756*^9, 
   3.4779700773824*^9, 3.4779701805296*^9, {3.4779720200506*^9, 
   3.4779720380374002`*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"accept ratios for be: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "0.5`", "}"}]}],
  SequenceForm["accept ratios for be: ", {0.5}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.4779193761981926`*^9, 3.4779194938689923`*^9, {3.4779201762455997`*^9, 
   3.477920228646*^9}, 3.4779202822320004`*^9, 3.477920387454*^9, {
   3.4779204708828*^9, 3.4779204787764*^9}, 3.4779205272768*^9, 
   3.477920922796*^9, 3.4779209617648*^9, 3.4779211165811996`*^9, 
   3.4779215756368*^9, 3.4779216784116*^9, 3.4779221453943996`*^9, 
   3.4779226684*^9, 3.4779227629988003`*^9, 3.4779228191516*^9, 
   3.47792290352*^9, 3.4779230308798*^9, 3.4779234532754*^9, 
   3.4779692812276*^9, 3.477969644633*^9, 3.477969863756*^9, 
   3.4779700773824*^9, 3.4779701805296*^9, {3.4779720200506*^9, 
   3.4779720383338003`*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"accept ratios for be: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "0.625`", "}"}]}],
  SequenceForm["accept ratios for be: ", {0.625}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.4779193761981926`*^9, 3.4779194938689923`*^9, {3.4779201762455997`*^9, 
   3.477920228646*^9}, 3.4779202822320004`*^9, 3.477920387454*^9, {
   3.4779204708828*^9, 3.4779204787764*^9}, 3.4779205272768*^9, 
   3.477920922796*^9, 3.4779209617648*^9, 3.4779211165811996`*^9, 
   3.4779215756368*^9, 3.4779216784116*^9, 3.4779221453943996`*^9, 
   3.4779226684*^9, 3.4779227629988003`*^9, 3.4779228191516*^9, 
   3.47792290352*^9, 3.4779230308798*^9, 3.4779234532754*^9, 
   3.4779692812276*^9, 3.477969644633*^9, 3.477969863756*^9, 
   3.4779700773824*^9, 3.4779701805296*^9, {3.4779720200506*^9, 
   3.4779720386458*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"4.8204`8.134628071275264", ",", "Null"}], "}"}]], "Output",
 CellChangeTimes->{
  3.477917242523*^9, 3.4779193771341925`*^9, 3.4779194950389924`*^9, {
   3.4779201804732*^9, 3.477920228646*^9}, 3.4779202822320004`*^9, 
   3.477920389014*^9, {3.4779204710544*^9, 3.4779204790884*^9}, 
   3.4779205303968*^9, 3.4779209234044*^9, 3.477920967568*^9, 
   3.4779211224156*^9, 3.4779215819236*^9, 3.4779216848543997`*^9, 
   3.477922151104*^9, 3.4779226684624*^9, 3.4779227636384*^9, 
   3.4779228201968*^9, 3.4779229045652*^9, 3.4779230319094*^9, 
   3.4779234543361998`*^9, 3.477969282304*^9, 3.4779696456782*^9, 
   3.4779698894960003`*^9, 3.4779700777567997`*^9, 3.4779701955836*^9, {
   3.4779720206745996`*^9, 3.4779720386458*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Do", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ta", "=", 
      RowBox[{"tass", "[", 
       RowBox[{"[", "z", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"tamu", "=", 
      RowBox[{"ta", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "1"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"f1", "=", 
      RowBox[{"ListPlot", "[", 
       RowBox[{
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"tamu", "[", 
           RowBox[{"[", 
            RowBox[{"All", ",", "1", ",", "i"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "2"}], "}"}]}], "]"}], ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"PlotRange", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"All", ",", "All"}], "}"}]}], ",", 
        RowBox[{"PlotLabel", "\[Rule]", "\"\<mu\>\""}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"taV", "=", 
      RowBox[{"ta", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "2"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"f2", "=", 
      RowBox[{"ListPlot", "[", 
       RowBox[{
        RowBox[{"Flatten", "[", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"taV", "[", 
             RowBox[{"[", 
              RowBox[{"All", ",", "1", ",", "i", ",", "j"}], "]"}], "]"}], 
            ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "1", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"j", ",", "1", ",", "2"}], "}"}]}], "]"}], ",", "1"}], 
         "]"}], ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"PlotRange", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"All", ",", "All"}], "}"}]}], ",", 
        RowBox[{"PlotLabel", "\[Rule]", "\"\<V\>\""}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tabe", "=", 
      RowBox[{"ta", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "3"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"f3", "=", 
      RowBox[{"ListPlot", "[", 
       RowBox[{
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"tabe", "[", 
           RowBox[{"[", 
            RowBox[{"All", ",", "1", ",", "i"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "2"}], "}"}]}], "]"}], ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"PlotRange", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"All", ",", "All"}], "}"}]}], ",", 
        RowBox[{"PlotLabel", "\[Rule]", "\"\<be1\>\""}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"taf", "=", 
      RowBox[{"ta", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "4"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"f4", "=", 
      RowBox[{"ListPlot", "[", 
       RowBox[{"taf", ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"PlotRange", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"All", ",", "All"}], "}"}]}], ",", 
        RowBox[{"PlotLabel", "\[Rule]", "\"\<f\>\""}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tamodel", "=", 
      RowBox[{"ta", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "5"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"f3", "=", 
      RowBox[{"ListPlot", "[", 
       RowBox[{
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"tamodel", "[", 
           RowBox[{"[", 
            RowBox[{"All", ",", "i"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"z", "\[Equal]", "1"}], ",", "10", ",", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"z", "\[Equal]", "2"}], ",", "5", ",", "1"}], "]"}]}],
              "]"}]}], "}"}]}], "]"}], ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"PlotRange", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"All", ",", "All"}], "}"}]}], ",", 
        RowBox[{"PlotLabel", "\[Rule]", "\"\<model\>\""}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Print", "[", 
      RowBox[{"Show", "[", 
       RowBox[{
        RowBox[{"GraphicsArray", "[", 
         RowBox[{"{", 
          RowBox[{"f1", ",", "f2", ",", "f3", ",", "f4"}], "}"}], "]"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Automatic", ",", "150"}], "}"}]}]}], "]"}], "]"}], ";"}], 
    "\[IndentingNewLine]", ",", 
    RowBox[{"{", 
     RowBox[{"z", ",", "3"}], "}"}]}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.4779205149684*^9, 3.4779205575594*^9}, {
  3.4779205897628*^9, 3.4779206025880003`*^9}, {3.4779209412508*^9, 
  3.4779209413444*^9}, {3.4779227839838*^9, 3.4779227916488*^9}, {
  3.4779228243464003`*^9, 3.4779228354379997`*^9}, {3.4779229088396*^9, 
  3.477922954704*^9}, {3.4779230610425997`*^9, 3.4779231100220003`*^9}, {
  3.4779696967525997`*^9, 3.4779697461788*^9}}]
},
WindowSize->{1424, 779},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
PrintingCopies->1,
PrintingPageRange->{Automatic, Automatic},
FrontEndVersion->"7.0 for Microsoft Windows (64-bit) (February 18, 2009)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[545, 20, 33067, 785, 2572, "Input"],
Cell[33615, 807, 17330, 452, 1332, "Input"],
Cell[50948, 1261, 4679, 123, 492, "Input"],
Cell[CellGroupData[{
Cell[55652, 1388, 355, 9, 31, "Input"],
Cell[CellGroupData[{
Cell[56032, 1401, 2643, 43, 81, "Print"],
Cell[58678, 1446, 958, 18, 23, "Print"],
Cell[59639, 1466, 858, 16, 23, "Print"],
Cell[60500, 1484, 858, 16, 23, "Print"]
}, Open  ]],
Cell[61373, 1503, 770, 13, 30, "Output"]
}, Open  ]],
Cell[62158, 1519, 5099, 131, 292, "Input"]
}
]
*)

(* End of internal cache information *)
